!Subroutine to update the jumpTree when an atom is deposited.  Need to zero the values out for covered atoms
!and calculate values for the newly deposited atom
!
!
subroutine depositionUpdate(depositedXIndex, depositedYIndex)

	integer :: oddModifier, coordination = 0
	integer, intent(in) :: depositedXIndex, depositedYIndex, i, leafIndex
	
	!Determine the evenness of the lattice site
	if (evenness > 0)	then
		oddModifier = 1
	endif
	
	!Check neighboring atoms coordination and update jump energies.
	!Set energies to zero is atom is now totally surrounded
	!We don't need to call the coordinationCalculation or anything, we can just do siteJumpInfo for all cases
	do i = -2, -1
	
		coordination = coordinationCalculation(depositedXIndex +i, depositedYIndex -1)
		leafIndex = gridToJump(depositedXIndex +i, depositedYIndex -1)
		if (coordination == 6)	then
			jumpEnergies(leafIndex) = 0.0
		else
			call siteJumpInfo(leafIndex)
		endif
		
		coordination = coordinationCalculation(depositedXIndex +i, depositedYIndex +1)
		leafIndex = gridToJump(depositedXIndex +i, depositedYIndex +1)
		if (coordination == 6)	then
			jumpEnergies(leafIndex) = 0.0
		else
			call siteJumpInfo(leafIndex)
		endif
	enddo
	
	coordination = coordinationCalculation(depositedXIndex -1, depositedYIndex)
	leafIndex = gridToJump(depositedXIndex -1, depositedYIndex)
	if (coordination == 6)	then
		jumpEnergies(leafIndex) = 0.0
	else
		call siteJumpInfo(leafIndex)
	endif
	
	coordination = coordinationCalculation(depositedXIndex +1, depositedYIndex)
	leafIndex = gridToJump(depositedXIndex +1, depositedYIndex)
	if (coordination == 6)	then
		jumpEnergies(leafIndex) = 0.0
	else
		call siteJumpInfo(leafIndex)
	endif