!Moves atoms around surface until next atom is deposited
!Builds a binary tree of all possible moves and then selects them
!Need subroutines to build tree, choose the jump, and perform it
!The binary tree will be empty at first and only fill up once the atoms begin depositing
!We don't need to put in everynew deposited atom or spot, just remember the rules
!
!11/14 Update: Changed the if statements for jumpTree values (> 0.0 instead of >0.001)
!Make sure jumpEnergies are initialized properly, we need to do this somewhere...
!12/3: I don't think making jumpEnergies pointers will change this file at all.  We only
!reference the values, not change or reassign them.
!Variables used:
!randomNum, jumpEnergySum, i, j, firstLeafIndex, jumpTree, depositTime, depositTimeInterval
!Modules & subroutines
!globalVariables, random_number, jumpTreeInitialize, jumpUpdate
subroutine diffuse()

	use globalVariables
	use indexConversion
	use coordinationHelpers
	use ifport
	real :: randomNum, jumpEnergySum
	integer :: j, i
	integer, dimension(1,2) ::coord

!	print *, 'Starting diffuse'

	!Before every diffuse step, reset the depositTime to the value between jumps
	depositTime = depositTimeInterval
	!print *, 'depositTime', depositTime
	j = 0
	i = 0
	
	!Go down the jumpTree randomly until you reach a leaf node
	do
		i =0
!		print *, 'Starting loop'
		do
			if (i >= firstLeafIndex) then
				!print *, 'I found a leaf', i
				!print * ,'Leaf error', i
				exit
			else
				!May need to reseed the random_number routine as in vaporInitialize
				!Scale the random number to the sum of the two leaf nodes
				!print *, 'in the thick of it', i
				randomNum = rand()
				
				!Check if both children have values, if not select the valued one
				if(jumpTree(2*i+1) > 0.0 .and. jumpTree(2*i+2) > 0.0) then
					!Lower energy values should be select perferentially
					randomNum = (jumpTree(2*i+1) + jumpTree(2*i+2)) * randomNum
					!!print *, 'Two children'
					!!print *, 'left' ,jumpTree(2*i+1), 'right', jumpTree(2*i+2)
					!Check if smaller than left child, select if so
					if (randomNum < jumpTree(2*i + 1)) then
					
						i = 2*i + 1
					!!print *, 'leftist'
					!Pick the right side	
					else
						i = 2*i + 2
						!!print *, 'rightest'
					endif
				elseif(jumpTree(2*i+1) == 0.0 .and. jumpTree(2*i + 2) /= 0.0) then
					!!print *, 'One child'
					i = 2*i + 2
				elseif(jumpTree(2*i+2) == 0.0 .and. jumpTree(2*i + 1) /= 0.0) then
					!!print *, 'One child'
					i = 2*i + 1
				else
				!This is happening on the initial deposition.  Do we want to wait a certain number
				!of depositions before beginning diffusion?, or make template ones elgible?
					!print *, 'Tree selector error, ended up with two zeros (crikey!)', jumpTree(i)
					!firstLeafIndex, i, jumpTree(i), jumpToGrid(2*i+1), movieIndex
					coord = jumpToGrid(2*i+1)
					!!print*, coordinationCalculation(coord(1,1),coord(1,2))
					!If we get caught in this loop, it'll be good just to give up and reset the index
					i = 0
				endif
			endif
		enddo
	!	print *, 'Naviagted jumpTree'
		
		!Pick the specific jump from the leaf node
		if (i < firstLeafIndex) then
			print *, 'Error, incorrect leaf index'
		else
			!Start j at 1, and have 6 elements per site
			!Uses the formula 6*x-5 to relate leaf to energy index
			j = jumpToEnergy(i)
		!	print *, 'jumpEnergies', jumpEnergies(j:j+5), probabilities(jumpEnergies(j:j+5))
			!Can jump to left
			if (probabilities(jumpEnergies(j+2)) > 0.0) then
				! Jump left and right
				if(probabilities(jumpEnergies(j+3)) > 0.0) then
				
					jumpEnergySum = probabilities(jumpEnergies(j+2)) + probabilities(jumpEnergies(j+3))
					randomNum = rand()
					randomNum = jumpEnergySum * randomNum
					if(randomNum < probabilities(jumpEnergies(j + 2))) then
				!		!print *, 'jump', 2
						call jumpUpdate(i, j + 2)
					else
				!		!print *, 'jump', 3
						call jumpUpdate(i, j + 3)
					endif
				!Jump left, Schwoebel up right
				elseif(probabilities(jumpEnergies(j+5)) > 0.0) then
				
					jumpEnergySum = probabilities(jumpEnergies(j+2)) + probabilities(jumpEnergies(j+5))
					randomNum = rand()
					randomNum = jumpEnergySum * randomNum
					if(randomNum < probabilities(jumpEnergies(j+2))) then
				!		!print *, 'jump', 4
						call jumpUpdate(i, j + 2)
					else
				!		!print *, 'jump', 5
						call jumpUpdate(i, j + 5)
					endif
				!Jump left, Schwoebel down right
				elseif(probabilities(jumpEnergies(j+1)) > 0.0) then
				
					jumpEnergySum = probabilities(jumpEnergies(j+2)) + probabilities(jumpEnergies(j+1))
					randomNum = rand()
					randomNum = jumpEnergySum * randomNum
					if(randomNum < probabilities(jumpEnergies(j + 2))) then
						!!print *, 'jump', 2
						call jumpUpdate(i, j + 2)
					else
						!!print *, 'jump', 1
						call jumpUpdate(i, j + 1)
					endif
				!Jump left only
				else
					!!print *, 'jump', 2
					call jumpUpdate(i, j + 2)
				endif
			!Can jump right or Schwoebel left only
			elseif(probabilities(jumpEnergies(j+3)) > 0.0) then
				!Jump right, Schwoebel up left
				if (probabilities(jumpEnergies(j+4)) > 0.0) then
				
					jumpEnergySum = probabilities(jumpEnergies(j+3)) + probabilities(jumpEnergies(j+4))
					randomNum = rand()
					randomNum = jumpEnergySum * randomNum
					if(randomNum < probabilities(jumpEnergies(j + 3))) then
						!!print *, 'jump', 3
						call jumpUpdate(i, j + 3)
					else
						!!print *, 'jump', 4
						call jumpUpdate(i, j + 4)
					endif
				!Jump right, Schwoebel down left
				elseif (probabilities(jumpEnergies(j)) > 0.0) then
				
					jumpEnergySum = probabilities(jumpEnergies(j+3)) + probabilities(jumpEnergies(j))
					randomNum = rand()
					randomNum = jumpEnergySum * randomNum
					if(randomNum < probabilities(jumpEnergies(j+3))) then
						!!print *, 'jump', 3
						call jumpUpdate(i, j + 3)
					else
						!!print *, 'jump', 0
						call jumpUpdate(i, j)
					endif
				!Jump right only
				else
					!!print *, 'jump', 3
					call jumpUpdate(i, j+3)
				endif
			else
				!print *, 'Error: atom is immobile'
			endif
		endif
		
		!Advance deposit time, need to find the formula for deposit time
	!	print *, 'depositTime before', depositTime, jumpTree(0)
		depositTime = depositTime - 1/jumpTree(0)
	!	print *, 'depositTime after', depositTime
		
		!Check deposit time interval and exit if moved for long enough
		randomNum = rand()
		numberOfDiffusions = numberOfDiffusions +1
		
		!If the depositTime is greater that the residency time (1/jumpTree(0)), then continue
		!If it is less than, see if their ratio is greater than a random number
		!If neither are true, end the diffusion routine.
		!print *, 'depositTime', depositTime, depositTimeInterval, '1/jumpTree', 1/jumpTree(0)
		if(depositTime > 1/jumpTree(0))	then
		elseif(depositTime*jumpTree(0) >randomNum)	then
			depositTime = 0
		else
			exit
		endif
	!	!print *, 'Made it through loop some'
	enddo
end subroutine diffuse