!
!	Header to specify common variables throughout fortran subroutines
!	Use include 'kmc.h' to access this file
!	Set the size of reals and integers (Bartel did it like this...)
module globalVariables

!	parameter (nbyte=4,ibyte=4) This is from Bartel, dunno if its necessary, it sets the data size
!	for different types, which would be useful, but I dunno how to do it right
	
!	Deposition constants, need common after to make the accessible

	integer ::  atomsToDeposit, numberOfInitialLayers, substrateWidth, coordination, singleNeighborLocation, existingRows
	integer :: atomCount, xIndex, yIndex, deposited, filmHeightMax, yVaporInitial, gridMaxHeight, boundaryConditionModifier
	real :: substrateTemperature, depositionTime, deltaYGrid, deltaXGrid, assumedDensity, start, finish, depositionRate
	integer :: evenIndex, oddIndex, numberOfDiffusions, moundNumber, moundSwitch, moundWidth,moundHeight,resumeSwitch
	integer :: loopSwitch, loopNumber, loopIndex, cycleMultiplier
	real, dimension(:), allocatable :: loopDepositionRate
	integer, dimension(:), allocatable :: loopAtomsToDeposit
	integer, dimension(:,:), allocatable :: atomPath
	integer, parameter :: shortInt = selected_int_kind (2)
	integer, parameter :: gridInt = selected_int_kind (1)
	real, parameter :: pi = 3.141592653589793

		
!	Creates a struct for gridLocations
!	If we use array indices, we don't need the separate xIndex and yIndex
!	(I think we can just use movieGrid for this)
!	The variable color will be used to make movies of the simulation process.
!	The color code is as follows: 1 = black, 2 = red, 3 = orange, 4 = grey, 5 = blue, 6 = brown, 0 = white (vacant)
	type, public :: gridIndex
!		integer :: xIndex
!		integer :: yIndex
		integer(kind = gridInt) :: occupationNumber
		!integer :: color
	end type gridIndex
	
	!Create movieGrid as a three dimensional array (x,y,timestep), I'm not sure if this will work...
	integer, dimension(:,:, :), allocatable :: movieGrid
	integer, dimension(:,:), allocatable :: initialGrid
	integer :: movieIndex, movieIndexMax
	
!	type(gridIndex) :: currentIndex

!	Define an array of variable dimensions, is this the right syntax for two dimensions?
!	Grid as two values for each spot
!	occupationNumber = 1 if occupied, 0 otherwise
!	diffusionIndex = 1 if moveable, 0 if in bulk for good
	type(gridIndex), dimension(:,:), allocatable :: grid
	
!	common /bk02/ depositedAtom
	
!	Create struct for vapor-phase atoms (one at a time)
	type, public :: vaporAtom
		real :: xVapor
		real :: thetaVapor
		integer :: yVapor
		real :: deltaYVapor
	end type vaporAtom
	
	!Create a variable of the struct type
	type(vaporAtom) :: newAtom
	
	real, dimension(:,:), allocatable :: depositionFlux
	real, dimension(-45:45) :: iAD, iADNormalized
	real :: depositTimeInterval, depositTime
	
	!Jump energy Indexing:
	!energyIndex = Schoewbel down left, +1 = Schoewbel down right, +2 = jump left, +3 = jumpRight
	!+4 = Schoewbel up left, +5 = Schoewbel up right
	real, dimension(:), allocatable :: jumpTree
	real, dimension(20) :: probabilities
	integer (kind = shortInt), dimension(:), allocatable  :: jumpEnergies
	integer :: leafN, treeSize, firstLeafIndex
	real :: maxLatticePoints

        
end module globalVariables