! kMSeed -- A 2D kinetic Monte Carlo program for deposition simulation
! Theron Rodgers 4/13/11
!Things to do: We have the program running now (with no diffusion) and are getting somewhat realistic results
!There are still plenty of things to work on however.
!Figure out what to do when an atom touches one particle beside it (or even below) this happens more than expected
!Figure out why there seems to be little depence on the IAD with the structure
!How can I fix the overwrite errors?
!Write the diffusion subroutiney

program main

	use globalVariables
	
	integer :: i,j,k
	character(len=1024) :: filename
	
	
	
	call CPU_TIME(start)
	call input
	print *, 'Input executed'
	
	!Set the maximum size of coating allowed in memory.  This would be a prime area to cut usage.
	if (loopSwitch == 1) then
		filmHeightMax = CEILING(numberOfInitialLayers + existingRows + ((atomsToDeposit/substrateWidth)/assumedDensity)*(loopNumber*cycleMultiplier))
	else
		filmHeightMax = CEILING(numberOfInitialLayers + existingRows + (atomsToDeposit/substrateWidth)/assumedDensity)
		loopNumber = 1
	endif
	print *, 'Film height max', filmHeightMax
	
	!Set up the grid() and movieGrid() arrays.  Account for mounds or restart conditions
	call gridInitialize
	print *, 'gridInitialize executed'
	
	!Create a list of atoms to deposit
	call vaporInitialize
	print *, 'vaporInitialize executed'
	!Initialize the parameters used during diffusion
	call diffusionInitialize
	print *, 'diffusionInitialize executed'
	!Determine the size of the jumpTree
	call jumpTreeInitialize
	print *, 'jumpTreeInitialize executed'
	
	movieIndex = 1
	numberOfDiffusions = 0

	
	!Start the main loop of the program
	do k = 1, cycleMultiplier
		do j = 1, loopNumber
	
			loopIndex = j
			!Update the IAD, atomsToDeposit, and depositionRate
			if (j > 1) then
				!Write the desired fileName to character variable
				write(filename, "(A,I0,A)") 'iad', 45*(j-1), 'Deg.in'
			
				!Read in the new IAD
				open (unit = 13, file = trim(filename))
				do i = -45,44
					read (unit = 13, fmt = *), iAD(i)
				enddo
			
				!Update varaibles
				atomsToDeposit = loopAtomsToDeposit(j)
				depositionRate = loopDepositionRate(j)
			
				!Update the time intervals between depositions
				depositTimeInterval = SQRT(3.0) * deltaXGrid /(2 * substrateWidth * depositionRate)
				close(13)
				deallocate(depositionFlux)
				call vaporInitialize
			
			endif	
		
			!This is the main deposition loop.
			do i = 1, atomsToDeposit

				atomCount = i
				call hexDeposit
		!		print *, 'hexDeposit executed ', i
				call diffuse
		!		print *, 'diffuse executed ', i
			enddo
			!Call the output for each major step, need to label files in the subroutine
			
		enddo
		if(MOD(k,10) == 0) then
			call output
		endif
	enddo
	call output
	call statistics
	
end