!
!	Header to specify common variables throughout fortran subroutines
!	Use include 'kmc.h' to access this file
!	Set the size of reals and integers (Bartel did it like this...)
module globalVariables

	parameter (nbyte=4,ibyte=4)
	
!	Deposition constants, need common after to make the accessible

	integer :: depositionRate, atomsToDeposit, numberOfInitialLayers
	integer :: atomCount, xIndex, yIndex, deposited
	real :: substrateTemperature, substrateWidth, depositionTime, evenness
	
!I don' think we need to allocate memory blocks like this
!	common /bk01/ depositionRate, atomsToDeposit, numberOfInitialLayers, &
!		substrateTemperature, substrateWidth, atomCount, depositionTime, evenness &
!		xIndex, yIndex, deposited
		
!	Creates a struct for gridLocations
!	If we use array indices, we don't need the separate xIndex and yIndex
	type gridIndex
!		integer :: xIndex
!		integer :: yIndex
		integer :: occupationNumber
		integer :: diffusionIndex
	end type gridIndex
	
!	common /bk02/ depositedAtom
	
!	Create struct for vapor-phase atoms (one at a time)
	type vaporAtom
		real :: xVapor
		real :: thetaVapor
		real :: yVapor
		real :: deltaYVapor
	end type vaporAtom
	
	real, dimension(-45:45) :: iAD, iADNormalized
	
end module globalVariables