	program KMC_of_thermalPVD
	implicit none
	include 'headfile'
	
	data rrni/2.44567d0/
	data eprecision/1.d-10/,epsilen1,epsilen2/2*0.2d0/,epsilen3,
     +		epsilen4/2*0.05d0/
	data deposition,redeposition,sub_print,nickel,traj_print,
     +	  cosine,polynom,rotate,rock,dwell,fullrock,dense,static_sub,
     +	 fullsub_print/14*.false./
	data exeinfo/'ppexeinfo'/,trajpre/'pptraj'/
     +	  ,subpre/'ppsub'/,errinfo/'pperrinfo'/
	namelist /rancard/run,rate,ts,nmbr,iran1,aa_rock,ML_os
     +		,dwell_lys,aa_cosinel,aa_cosiner,dwell_ratio,ncut,
     +		cos_power
	namelist /truecard/nickel,deposition,redeposition,rock,fullrock
     +	,rotate,sub_print,traj_print,fullsub_print,polynom,dwell,cosine,
     +		dense,static_sub
	namelist /polynomialcard/c0,c1,c2,c3,c4,c5,c6,c7,c8,c9

c
c	read inputs
c
	open(27,file='rdcard')
	read(27,rancard)
	read(27,truecard)
	read(27,polynomialcard)
	
c
c   running records.
c	I'm not quite sure what these values are for... or are useful	
	err_out = errinfo//run
	exehint = exeinfo//run
	traj = trajpre//run
	sub = subpre//run
	open(59,file = exehint,status = 'unknown')
	open(11,file = err_out,status = 'unknown')
	write(59,2000)
2000	format(/,10x,'RUNNING DATA')
	write(59,*)" "
	write(11,3000)
3000	format(/,10x,'RUNNING FLAG')
	write(11,*)" "
c	This sets up lots of parameters before execution.
c	Not all of them will be necessary, so can go through later and cull

	nfuse = 0
	myy = 1
	Tix = 0
	norder = 0
	rr = 10.d0
	dx = 2.d0*rr
	dy = rr*srt3
	rateroot = 0.d0
	iperlen = mx*itot
	write(59,2010)iperlen
2010	format(1x,'periodic length in atoms',1i6)
	perlen = dx*(iperlen - 1)
	write(59,2020)perlen
2020	format(1x,'periodic length in units',1f8.2)
	pi = 4.d0*atan(1.d0)
	rad1 = 180.d0/pi
	seedin = iran1
	write(59,2030)seedin
2030	format(/,1x,'seed',1i8)
	if (cosine) then
	    write(59,5000)aa_cosinel
	    write(59,5010)aa_cosiner
	    write(59,5030)cos_power
5000	    format(/,1x,'cosine distribution left bound',1f5.1)
5010	    format(/,1x,'cosine distribution right bound',1f5.1)
5030	    format(/,1x,'cosine distribution to the power',1f4.1)
	else
	    write(59,5020)
5020	    format(/,1x,'distribution in polynomial')
	endif
	if (static_sub) then
	    write(59,5031)
5031	    format(/,1x,'substrate in static',1f5.1)
	else
c	Will eventually probably want this more complex, more rotation than rock.
	  if (dwell) then
	    write(59,5040)dwell_lys
	    write(59,5042)dwell_ratio
	    write(59,5044)aa_rock
5040	    format(/,1x,'dwell layers',1i8)
5042	    format(/,1x,'dwell ratio',1i8)
5044	    format(/,1x,'dwell (sub) magnitude in deg',1f8.1)
	  elseif (rock) then
	    write(59,5060)ML_os
	    write(59,5061)aa_rock
5060	    format(/,1x,'rock rate in monolayers/oscilation',1f8.1)
5061	    format(/,1x,'rock magnitude in deg.',1f8.1)
	  elseif (fullrock) then
	    write(59,5080)ML_os
5080	    format(/,1x,'full rock rate in monolayers/oscilation',1f8.1)
	  elseif (rotate) then
	    write(59,5082)
5082	    format(/,1x,'rotation rate in ?')
	  else
	    write(11,6000)
	    stop
6000	    format(/,1x,'setup error')
	  endif
	endif
	aa_rock = aa_rock/rad1
	aa_increment = (4.d0*aa_rock)/(ML_os*mx*itot)
	if (static_sub) then
	  aa_dev = 0.d0
	else
          aa_dev = aa_rock
	  aa_temp = aa_rock
	endif
        nDerek = 0
        nnDerek = 1
	if (dwell) then
	  dwell_no = dwell_ratio*dwell_lys*mx*itot/(dwell_ratio+1.d0)
	  nondwell_no = dwell_lys*mx*itot - dwell_no
	  aa_increment = (2.d0*aa_rock)/(nondwell_no)
	endif
	dwell_time = .true.
	safetypin = pi/2.d0-5.d0/rad1
	delta_t = srt3*rrni*60.d0/(2.d0*itot*rate*10000.d0) !10000(A)/60(sec)
	dtc = delta_t
	yardstick = rr/3.d0
	if(deposition)then
	  idsub = .true.
	elseif(redeposition)then
	  idsub = .false.
	endif 

	!__sub parameters.
	if(mx.ne.4*int(mx/4))then
	  !stop
	endif
	nbase = 8
	slope1 = 0.d0/rad1
	slope2 = 0.d0/rad1
	ratio = 0.0d0
	if (ratio .gt. 0.d0) then
	  stop
	endif
	ratiol = ratio/(1.d0-0.5d0*ratio*(tan(slope1)+tan(slope2)))
	itable1s = int(mx/4)*itot
	itable2s = int(mx/4)*itot
	mouth = int(mx/2)*itot	!beware of mx*itot & iperlen.

	!__barriers.
	call barriers

        !__rates and zero stats.
        do i = 0, 5			!0 to prevent funny thing.
          do j = 1, 5
            if(barrier(i,j).eq.5000.d0)then
              ppb(i,j) = 0.d0
              goto 1028
            elseif(barrier(i,j).eq.0.d0)then
              ppb(i,j) = frqcy
              goto 1028
            endif
            ppb(i,j) = frqcy*exp(-barrier(i,j)/(bk*ts))
1028      end do
        end do

	write(59,2600) rate
2600	format(1x,'deposition rate(micron/min)=',1f8.2)
	write(59,2700) ts
2700	format(1x,'substrate temperature(K)=',1f8.2)

c
c	initial status.
c
	do j = 1, my*itot
	  do i = 1, iperlen
	    grids(i,j,1) = 0		!default occupation.
	    grids(i,j,2) = -1		!default serial no.
	    grids(i,j,3) = -1		!default jump status.
	    grids(i,j,4) = -1		!default hash.
	    grids(i,j,5) = -1		!default surface status.
	  enddo
	enddo
	do i = 1, surfmax
	  nbox(i) = -1                  !hash no. initiated to -1.
        enddo                           !if occupied, the 'nhh' value.
                                        !if deleted, flag as 0.

c
c	sub initiation.
c
	if(idsub)then
	  call subcreat()
	else
	  call subfilm()
	endif

	!__dep order.
	if(redeposition)then
	  istarter = norder+1
	  nmbr = norder+nmbr
	else
	  istarter = 1
	endif

	!__sub rate initiation.
	call rateinit
	
c
c	deposition
c
	do kk = istarter, nmbr
	  call incid
	  call addatom(rz3,rz4,ntfx,ntfy)
	  call nnlax(ntfx,ntfy,rz3,rz4,ii,jj)
61        if (kk-norder .ne. mx*myy) goto 60    !atoms for delta t.
	  call diffusion
	  myy = myy + 1
60	enddo

c
c	set checking flags.
c
	nn = 0
	mm = 0
 	do i = 1, surfmax
	  jfrom=(nbox(i)-1)/NBD+1
          ifrom=nbox(i)-(jfrom-1)*NBD
	  if(grids(ifrom,jfrom,3).eq.0)then
	    write(11,*)"error at",i,nbox(i)
	  endif
 	  if(nbox(i).eq.0)then
 	    nn = nn + 1
 	  elseif(nbox(i).eq.-1)then
 	    mm = mm + 1
	  else
	    !write(11,*)i
	    !write(11,*)i,nbox(i)
	    !write(11,*)nbox(i)
	    !write(11,*)ifrom,jfrom
 	  endif
 	enddo
	write(11,3010)
3010	format(/,1x,'.....................................')
 	write(11,3020)nn
3020	format(1x,'sites once visited',1i6)
 	write(11,3030)mm
3030	format(1x,'sites never visited',1i6)
	write(11,3040)mm+nn
3040	format(1x,'sites not occupied',1i6)
	write(11,3050)
3050	format(/,1x,'.....................................')
 	nn = 0
 	mm = 0
	!----------------------
	surfatom = 0
	do j=1, my*itot
          do i=1, iperlen
             if (grids(i,j,3) .eq. 1) surfatom = surfatom + 1
	     !if (grids(i,j,3). eq. 1) write(11,*) grids(i,j,4)
	     !if(grids(i,j,3).eq.1)then
	     !  print *,grids(i,j,4)
	     !endif
          enddo
        enddo
	write(11,3006)surfatom
3006	format(1x,'no. of surface atoms =',1i6)
	!----------------------
	
c
c	output trajectory.
c
	if (sub_print) call subprint
	if (traj_print) call trajprint()
	if (dense) call density(ncut)

	write(59,2900) Tix
2900	format(/,1x,'total number of jumps',1i8)

	close(59)
	close(11)
	close(27)
	stop
	end
c	This is the end of the actual main function.  Most everything else happens in the guts
c	Things to figure out: Where does this loop?  Does this utilize the complicated energy effects.
	
	
c--------------------------------------------------
c	Takes the indicies of lattice positions and translates them into coordinates (in meters?)
	subroutine square(i,j,x,y)
	implicit none

c	(x, y) given (i, j).

	integer i,j,iperlen
	real*8 x,y,dx,dy,rr,perlen
	common /latticedat/ perlen,dx,dy,rr,iperlen

	x = rr*(2*(i-1) + mod(j+1, 2))
        y = dy*(j-1)
	return
	end
	
c	Routine to actually go through and put atom on the grid.
c	Finds the atoms position and then finds the nearest grid site.
c	Attaches to grid.
c	DOES NOT relax atom, only intial placement.
	subroutine addatom(rz3,rz4,ntfx,ntfy)
	implicit none

c	hh, tt -- initial incident atom's position.
c	aa -- not explicitly used but through xsin and xcos.
c	rz3, rz4 -- incident atom's position before relax.
c	ntfx, ntfy -- index of touch atom.

	integer surfmax,lvl,NBD
	parameter(lvl=16)
	parameter(NBD=4000,surfmax=2**lvl)
	integer ii1,ii2,jj1,jj2
	integer ntfx,ntfy,ii,jj,iflag,i,j,idgrid,kk,iperlen
	integer itot,mx,my,iaddr,iaddl,nfuse,perlenc1,iw
	parameter(itot=50,mx=16,my=30,idgrid=5)
        integer grids(mx*itot,my*itot,idgrid)
	real*8 hh,tt,rz3,rz4,delta_len,yardstick,xsin,xcos
	real*8 perlen,xi,yi,rr,dd,dis,xdis,ydis
	real*8 epsilen1,epsilen2,epsilen3,epsilen4
	real*8 eprecision,two,ypeak,dx,dy,dist1,dist2
        integer NPOSpath(surfmax,5),nbox(surfmax)
        real*8 NPOSrate(surfmax,5)
	integer ipath(surfmax)
	parameter(two = 2.d0)
	common/kkdat/kk
	common/hhttdat/hh,tt
	common/gridsdat/grids
	common/nfusedat/nfuse
	common/ypeakdat/ypeak
        common /ipathdat/ ipath
        common/eprecisiondat/eprecision
	common/yardstickdat/yardstick,xsin,xcos
	common /latticedat/ perlen,dx,dy,rr,iperlen
	common/NPOSdat/NPOSrate,nbox,NPOSpath
	common/epsilendat/epsilen1,epsilen2,epsilen3,epsilen4

        rz3 = tt
        rz4 = hh
	delta_len = yardstick
1949    continue
        rz3 = rz3+delta_len*xsin
        rz4 = rz4-delta_len*xcos
	if (rz3 .gt. perlen) rz3 = rz3 - perlen
	if (rz3 .lt. 0.d0) rz3 = rz3 + perlen

        !__the closest lattice site.
	call tag(rz3,rz4,ii1,jj1)
	if (ii1 .lt. 1 .or. ii1 .gt. iperlen) then
	  ii1 = perlenc1(ii1)
        endif
	call square(ii1,jj1,xi,yi)
	xdis = rz3 - xi
        xdis = xdis - perlen*nint(xdis/perlen)
        ydis = rz4 - yi
        dist1 = sqrt(xdis**2 + ydis**2)
	if (yi .ge. rz4) then
          jj2 =jj1 - 1
	  ii2 = nint((rz3 - (mod(jj2+1,2)*rr))/dx + 1.d0)
	  if (ii2 .lt. 1 .or. ii2 .gt. iperlen) then
	    ii2 = perlenc1(ii2)
          endif
        else
          jj2 =jj1 + 1
          ii2 = nint((rz3 - mod(jj2+1, 2)*rr)/dx + 1.d0)
	  if (ii2 .lt. 1 .or. ii2 .gt. iperlen) then
	    ii2 = perlenc1(ii2)
          endif
        endif
	call square(ii2,jj2,xi,yi)
	xdis = rz3 - xi
        xdis = xdis - perlen*nint(xdis/perlen)
        ydis = rz4 - yi
        dist2 = sqrt(xdis**2 + ydis**2)
	if (dist1 .le. dist2) then
          ii = ii1
          jj = jj1
        else
          ii = ii2
          jj = jj2
        endif
1950	iflag = 0
	do j = jj-1, jj+1
	  iaddl=jj-(jj/2)*2+(1-abs(j-jj))*(jj-1-((jj-1)/2)*2)
          iaddr=jj-1-((jj-1)/2)*2+(1-abs(j-jj))*(jj-(jj/2)*2)
	  do i = ii-iaddl, ii+iaddr
	    if (i .lt. 1 .or. i .gt. iperlen) then
              iw = perlenc1( i )
            else
              iw = i
            endif
	    if(grids(iw,j,3).eq.1)then
	      call square(i,j,xi,yi)
	      xdis = rz3 - xi
              xdis = xdis - perlen*nint(xdis/perlen)
              ydis = rz4 - yi
              dd = sqrt( xdis**2 + ydis**2 )
	      if (dd .gt. dx) goto 1968
              epsilen3 = epsilen1
              epsilen4 = epsilen2
1951	      xdis = rz3 - xi
              xdis = xdis - perlen*nint(xdis/perlen)
              ydis = rz4 - yi
              dd = sqrt( xdis**2 + ydis**2 )
              dis = abs( dd - dx )
              if (dis .le. eprecision) then
                ntfx = i
                ntfy = j
                goto 1968
              endif
              if (dd .lt. dx) then
                iflag = iflag+1
                if(iflag.gt.999999)then
		  write(11,3007)kk
3007	          format(1x,'error iflag at addatom kk =',1i6)
                  ntfx = i
                  ntfy = j
                  goto 1968
                endif
                if(dis/epsilen3.gt.1.d0)then
                  delta_len = -epsilen4
                  rz3 = rz3+delta_len*xsin
                  rz4 = rz4-delta_len*xcos
                  goto 1951
                else
		  epsilen3 = dis/two
		  epsilen4 = epsilen3
                  delta_len = -epsilen4
		  rz3 = rz3+delta_len*xsin
                  rz4 = rz4-delta_len*xcos
                  goto 1951
                endif
              else
                rz3 = rz3-delta_len*xsin         !recover the prior values.
                rz4 = rz4+delta_len*xcos
                epsilen3 = epsilen3/two
                epsilen4 = epsilen3
                delta_len = -epsilen4
                rz3 = rz3+delta_len*xsin
                rz4 = rz4-delta_len*xcos
                goto 1951
              endif
            endif
1968	  enddo
	enddo
	if (iflag .eq. 0) then
	  delta_len = yardstick
          goto 1949
        endif

	!__avoid case in which ntfx is out of the system.
	if (ntfx .lt. 1) then
	  ntfx = ntfx + iperlen
	  rz3 = rz3 + perlen
	elseif (ntfx .gt. iperlen) then
	  ntfx = ntfx - iperlen
	  rz3 = rz3 - perlen
        endif
	return
	end

c	Throws the atom to the right place like the swine it is.
c	
	subroutine nnlax(ntfx,ntfy,rz3,rz4,ii,jj)
	implicit none

c	ntfx, ntfy -- index of the touch atom.
c	rz3, rz4 -- coordinates of the incident atom before relaxation.
c	ii, jj -- index of the incident atom after relaxation.
c	yy -- y coordinate of the incident atom after relax for ypeak.

	integer ntfx,ntfy,ii,jj,nbig,idenv,nrv,nvrv(8),nvrw(8),lvl
	real*8 rz3,rz4,yy,rmin,vrv,vrw,dx,rr,dd,perlen
	real*8 xdis,ydis,ypeak,dy
	parameter(nbig=2147483647,lvl=18)
	integer iaffect(200),jaffect(200)
	integer itot,mx,my,idgrid,i,kk,nat,iperlen
	parameter(itot=50,mx=16,my=30,idgrid=5)
	integer grids(mx*itot,my*itot,idgrid)
	integer surfmax,NPOS,NBD,nhh
	parameter(surfmax=2**lvl,NBD=4000)
	integer NPOSpath(surfmax,5),nbox(surfmax)
	real*8 NPOSrate(surfmax,5)
	common /latticedat/ perlen,dx,dy,rr,iperlen
	common/NPOSdat/NPOSrate,nbox,NPOSpath
	common/ypeakdat/ypeak
	common/gridsdat/grids
	common/kkdat/kk

	rmin = dfloat(nbig)
	idenv = 0
	call environ(idenv,ntfx,ntfy,nrv,nvrv,nvrw)
	if (nrv.eq.0) write(59,*)"error nrv got 0 at kk:",kk	 
	do i = 1, nrv
	  call square(nvrv(i),nvrw(i),vrv,vrw)
          xdis = rz3 - vrv
          xdis = xdis - perlen*nint(xdis/perlen)
          ydis = rz4 - vrw
          dd = sqrt( xdis**2 + ydis**2 )
	  if (dd .lt. rmin) then
	    ii = nvrv(i)
	    jj = nvrw(i)
	    yy = vrw
	    rmin = dd
	  endif
	enddo
	if (yy.gt.ypeak) ypeak = yy
	if (grids(ii,jj,1).ne.0) then
	  write(59,*)"error at nnlax at kk = ",kk
	endif
	if (jj .ge. my*itot) then
	  write(6,*)"error too small a my."
	endif

	grids(ii,jj,1) = 1
	grids(ii,jj,2) = kk
	grids(ii,jj,3) = 1
	grids(ii,jj,5) = 0

c
c	hash number
c
	NPOS = ii+(jj-1)*NBD
        nhh = mod(NPOS, surfmax)
 8      nhh = nhh + 1
        if(nhh .gt. surfmax) nhh = 1
        if (nbox(nhh) .gt. 0) goto 8
        nbox(nhh) = NPOS	
cc These subroutines may have the energy effects, may be something to cut
	call atomaffect(ii,jj,ii,jj,iaffect,jaffect,nat)
	call rateupdate(iaffect,jaffect,nat)
	return
	end

cc	Determines the number of neighbors around a point
	subroutine environ(idenv,ieb,jeb,nrv,nvrv,nvrw)
	implicit none

c	idenv -- 0 if needing vacant neighborhood 1 if needing otherwise.
c	ieb, jeb -- pointed position; can either vacant or occupied site.
c	nrv -- number of needed neighbor sites to-be-return.
c	nvrv, nvrw -- x & y index of those to-be-return sites.
c	version -- similar to former "useempty".

	real*8 perlen,dy,dx,rr
	integer idenv,ieb,jeb,nrv,nvrv(8),nvrw(8)
	integer itot,mx,my,iaddl,iaddr,perlenc1,iperlen
	integer i,j,nfuse,nback1,idgrid,iw
	parameter(itot=50,mx=16,my=30,idgrid=5)
        integer grids(mx*itot,my*itot,idgrid)
	common /latticedat/ perlen,dx,dy,rr,iperlen
	common/gridsdat/grids
	common/nfusedat/nfuse

	nrv=0	
	if(idenv.eq.0)then		!need vacant neighbors.
	  do j = jeb-1, jeb+1
	    iaddl=jeb-(jeb/2)*2+(1-abs(j-jeb))*(jeb-1-((jeb-1)/2)*2)
            iaddr=jeb-1-((jeb-1)/2)*2+(1-abs(j-jeb))*(jeb-(jeb/2)*2)
	    do iw = ieb-iaddl, ieb+iaddr
	      if (iw .lt. 1 .or. iw .gt. iperlen) then
                i = perlenc1( iw )
              else
                i = iw
              endif
	      if (grids(i,j,1) .eq. 0) then
	        call neighbor(i,j,nfuse,nback1)
		if(nback1.gt.1)then
		  nrv=nrv+1
		  nvrv(nrv)=i
		  nvrw(nrv)=j
	        endif
	      endif
	    enddo
	  enddo
	endif
	return
	end
	
c Initializes the binary tree data structure of available sites
c This structure will be important if I rewrite the program.
	subroutine rateinit
	implicit none
c	
c	Binary tree used.

	logical idsub
	integer nj,i,j,mx,my,itot,iup,iperlen,iw,lvl
	parameter(lvl=18)
	integer NPOS,NBD,nfuse,nback1,nc1,ii,jj,nhh
	integer idgrid,iaddl,iaddr,kk, icome, jcome
	integer surfmax,nbase,perlenc1,m
	parameter(surfmax=2**lvl,NBD=4000)
        integer ipath(surfmax)
	parameter(itot=50,mx=16,my=30,idgrid=5)
        integer grids(mx*itot,my*itot,idgrid)
	integer NPOSpath(surfmax,5),nbox(surfmax)
	real*8 NPOSrate(surfmax,5),dy
	real*8 dx,rr,perlen,ppb(0:5,5),ypeak
	real*8 anode(0:lvl,2**lvl)
	common /anodedat/ anode
	common /nfusedat/ nfuse
	common /kkdat/ kk
	common /njdat/ nj
	common /ppbdat/ ppb
        common /ypeakdat/ ypeak
	common /gridsdat/ grids
        common /ipathdat/ ipath
	common /sub0dat/ idsub,nbase
	common/NPOSdat/NPOSrate,nbox,NPOSpath
	common /latticedat/ perlen,dx,dy,rr,iperlen
	
	!__clear ipath.
	do i = 1, 2**lvl
	  ipath(i) = 0
	enddo
	call tag(perlen,ypeak,icome,jcome)
	do j=1, jcome + 2
	  do i=1, icome
	    if(grids(i,j,3).eq.1)then
	      NPOS = i + (j-1)*NBD
	      nhh = mod(NPOS, surfmax)
 8	      nhh = nhh + 1
	      if(nhh .gt. surfmax) nhh = 1
	      if (nbox(nhh) .gt. 0) goto 8
	      nbox(nhh) = NPOS
	      ipath(nhh) = 0
	      call neighbor(i,j,nfuse,nback1)
	      nc1 = nback1
	      do jj=j-1, j+1
		iaddl=j-(j/2)*2+(1-abs(jj-j))*(j-1-((j-1)/2)*2)
                iaddr=j-1-((j-1)/2)*2+(1-abs(jj-j))*(j-(j/2)*2)
	        do iw=i-iaddl, i+iaddr
	  	  if (iw .lt. 1 .or. iw .gt. iperlen) then
		    ii = perlenc1( iw )
            	  else
              	    ii = iw
            	  endif
		  if (grids(ii,jj,1) .ne. 0) goto 15
		  nfuse = 1
		  call neighbor(ii,jj,nfuse,nback1)
	   	  if (nback1 .ge. 1) then
		    ipath(nhh) = ipath(nhh) + 1
		    NPOSpath(nhh,ipath(nhh)) = ii+(jj-1)*NBD
		    NPOSrate(nhh,ipath(nhh)) = ppb(nc1,nback1)
	          endif
15	        enddo
	      enddo
	    endif
	  enddo
	enddo

	!__clear the base nodes.
	do m = lvl, 0, -1
          do i = 1, 2**m
            anode(m,i) = 0.d0
          enddo
        enddo

        !__fill up the base nodes.
        do i=1, 2**lvl
          do j=1, ipath(i)
            anode(lvl,i) = anode(lvl,i) + NPOSrate(i,j)
          enddo
        enddo

        !__add the tree up.
        do j = lvl, 1, -1
          do i = 1, 2**j, 2
            iup = (i + 1)/2
            anode(j - 1, iup) = anode(j, i) + anode(j, i+1)
          enddo
        enddo
	return
	end
   

c This is the control loop for diffusion goes until th next particle is deposited	
	subroutine diffusion
	implicit none
c
c	main loop.
c

	logical autox,freex
	integer i,j,jumpPOS,jto,ito,kk,lvl
	parameter(lvl=18)
	integer jfrom,ifrom,NBD,surfmax,ix
	integer nmbr,Tix,iperlen
	parameter(NBD=4000,surfmax=2**lvl)
	integer NPOSpath(surfmax,5),nbox(surfmax)
	integer nfuse
	real*8 NPOSrate(surfmax,5)
	real*8 dtc,dtime,delta_t,dy
	real*8 perlen,rr,dx,rateroot
	integer mx,my,itot,idgrid
	parameter(itot=50,mx=16,my=30,idgrid=5)
        integer grids(mx*itot,my*itot,idgrid)
	real*8 anode(0:lvl,2**lvl)
        common /anodedat/ anode
        common /raterootdat/ rateroot
	common/nfusedat/nfuse
	common /latticedat/ perlen,dx,dy,rr,iperlen
	common/NPOSdat/NPOSrate,nbox,NPOSpath
	common/delta_tdat/delta_t
	common/gridsdat/grids
	common/dtcdat/dtc
	common/ifromdat/ifrom,jfrom
	common/itodat/ito,jto
	common/nmbrdat/nmbr
	common/ixdat/ix
	common/kkdat/kk
	common /Tixdat/ Tix

	ix=0
	dtc=delta_t
    	dtime = 1.d0/rateroot
 7	continue

	if (dtc .gt. dtime) then
c
c	jump path selection.
c
          CALL jumppick(i,j)
	  jumpPOS = NPOSpath(i,j)
	  jto = (jumpPOS-1)/NBD + 1
	  ito = jumpPOS - (jto - 1)*NBD
	  jfrom = (nbox(i) - 1)/NBD + 1
	  ifrom = nbox(i) - (jfrom - 1)*NBD
	  call autolax1(ifrom,jfrom)
	  call leap(autox,freex)
	  ix = ix + 1
    	  dtime = 1.d0/rateroot
	  dtc = dtc - dtime
	  goto 7
	endif
818	Tix = Tix + ix
  	return
	end

c Not sure what all this does, does it just avoid single bonds?
	subroutine autolax1(ihh,jhh)
	implicit none
	
c	avoid rare single bond.

	real*8 perlen,dx,dy,rr
	integer ihh,jhh,lac,i,j,mx,my,itot,idgrid
	integer kk,iaddl,iaddr,iw,perlenc1,iperlen
	integer nnx(6),nny(6)
	parameter(itot=50,mx=16,my=30,idgrid=5)
        integer grids(mx*itot,my*itot,idgrid)
	common /latticedat/ perlen,dx,dy,rr,iperlen
	common/lacdat/lac
	common/newtondat/nnx,nny
	common/gridsdat/grids
	common/kkdat/kk

	lac=0
	do j=jhh-1, jhh+1
	  iaddl=jhh-(jhh/2)*2+(1-abs(j-jhh))*(jhh-1-((jhh-1)/2)*2)
          iaddr=jhh-1-((jhh-1)/2)*2+(1-abs(j-jhh))*(jhh-(jhh/2)*2)
	  do iw=ihh-iaddl, ihh+iaddr
	    if (iw .lt. 1 .or. iw .gt. iperlen) then
              i = perlenc1( iw )
            else
              i = iw
            endif
	    if(grids(i,j,1).eq.1)then
	    if(i.eq.ihh.and.j.eq.jhh)goto 10
	      lac=lac+1
	      nnx(lac)=i
	      nny(lac)=j
	    endif
10	  enddo
	enddo
	return
	end

c	The decision to jump has been made.  This is the machinery to do it.
    subroutine leap(autox,freex)
	implicit none
c
c	make the jump.
c

	logical autox,freex
	integer nfuse,nback1,izz,lvl
	parameter(lvl=18)
	integer nnx(6),nny(6),lac,i,iperlen
	integer iaffect(200),jaffect(200),nat
	integer ifrom,jfrom,ito,jto,mx,my,itot,idgrid
	parameter(itot=50,mx=16,my=30,idgrid=5)
        integer grids(mx*itot,my*itot,idgrid)
	integer NPOS,NBD,kk,ix,iitrace,jjtrace
	integer surfmax,nhh,nhho
	parameter(NBD=4000,surfmax=2**lvl)
	integer NPOSpath(surfmax,5),nbox(surfmax)
	real*8 NPOSrate(surfmax,5)
	real*8 perlen,rr,dx,yy,ypeak,dy,srt3
	parameter(srt3=1.7320508d0)
        integer ipath(surfmax)
        common /ipathdat/ ipath
	common/lacdat/lac
	common/nfusedat/nfuse
	common/newtondat/nnx,nny
	common/gridsdat/grids
	common/NPOSdat/NPOSrate,nbox,NPOSpath
	common /latticedat/ perlen,dx,dy,rr,iperlen
	common/iijjtracedat/iitrace,jjtrace
	common/itodat/ito,jto
	common/ifromdat/ifrom,jfrom
        common/ypeakdat/ypeak
	common/ixdat/ix
	common/kkdat/kk

	autox = .true.
	freex = .true.
        yy = rr*srt3*(jto-1)
        if (yy .gt. ypeak) ypeak = yy
	if (grids(ito,jto,1).eq.1) then
	  write(59,*)"error LEAP kk=",kk
	  write(59,*)"error LEAP ix=",ix
	endif
	
	!__make a jump.
	grids(ito,jto,1)=1
	grids(ito,jto,2)=grids(ifrom,jfrom,2)
	grids(ito,jto,3)=1
	grids(ito,jto,5)=grids(ifrom,jfrom,5)
	grids(ifrom,jfrom,1)=0
	grids(ifrom,jfrom,2)=-1
	grids(ifrom,jfrom,3)=-1
	grids(ifrom,jfrom,5)=-1

	NPOS=ifrom+(jfrom-1)*NBD
	nhh = mod(NPOS, surfmax)
 8      nhh = nhh + 1
        if(nhh .gt. surfmax) nhh = 1
        if(nbox(nhh) .ne. NPOS) goto 8
        do izz=1, ipath(nhh)		!__clear NPOSrate & ipath & nbox.
          NPOSrate(nhh,izz) = 0.d0
        enddo
        CALL treeupdate(nhh)		!__update tree.
        nbox(nhh) = 0

	NPOS=ito+(jto-1)*NBD
	nhho = mod(NPOS, surfmax)
 9      nhho = nhho + 1
        if(nhho .gt. surfmax) nhho = 1
        if(nbox(nhho) .gt. 0) goto 9
        nbox(nhho) = NPOS
        ipath(nhh) = 0

        do i=1, lac			!__specials.
          call neighbor(nnx(i),nny(i),nfuse,nback1)
          if (nback1 .eq. 1) then
	    call autolax2(ifrom,jfrom)
	    goto 10
	  endif
        enddo
10	call neighbor(ito,jto,nfuse,nback1)
        if (nback1.eq.1) then
	  call freestand(ifrom,jfrom)
	elseif(nback1 .eq. 0) then
	  grids(ito,jto,1)=0
          grids(ito,jto,2)=-1
          grids(ito,jto,3)=-1
          grids(ito,jto,5)=-1
          do izz =1, ipath(nhho)
            NPOSrate(nhho,izz) = 0.d0
          enddo
          CALL treeupdate(nhho)            !__update tree.
          nbox(nhho) = 0
          ipath(nhho) = 0
          call atomaffect(ito,jto,ito,jto,iaffect,jaffect,nat)
          call rateupdate(iaffect,jaffect,nat)
	endif
	call atomaffect(ito,jto,ifrom,jfrom,iaffect,jaffect,nat)
	call rateupdate(iaffect,jaffect,nat)
	return
	end


 	subroutine rateupdate(iaffect,jaffect,nat)
	implicit none
c
c	rate updating.
c

	integer iaffect(200),jaffect(200),nat,inorm
	integer izz,perlenc1,iw,iperlen,lvl
	parameter(lvl=18)
	real*8 barrier(0:5,5),ppb(0:5,5),frqcy,bk
	parameter(frqcy=5.d+12,bk=8.625d-5)
	integer ifrom,jfrom,ito,jto,j
	integer NPOS,NBD,nc1,nback1,ix
	integer surfmax,nauto,kk,ik
	parameter(NBD=4000,surfmax=2**lvl)
	integer itot,mx,my,iii,jjj,nfuse,idgrid
	integer iaddl,iaddr,nhh
	parameter(itot=50,mx=16,my=30,idgrid=5)
        integer grids(mx*itot,my*itot,idgrid)
	integer NPOSpath(surfmax,5),nbox(surfmax)
	real*8 NPOSrate(surfmax,5),perlen,dy,dx,rr
        integer ipath(surfmax)
        common /ipathdat/ ipath
	common/nfusedat/nfuse
	common/nautodat/nauto
	common/gridsdat/grids
	common/kkdat/kk
	common/ixdat/ix
	common/ppbdat/ppb
	common/itodat/ito,jto
	common/barrierdat/barrier
	common/ifromdat/ifrom,jfrom
	common/NPOSdat/NPOSrate,nbox,NPOSpath
	common /latticedat/ perlen,dx,dy,rr,iperlen

	do inorm = 1, nat
	  ik = iaffect(inorm)
	  j = jaffect(inorm)
	  if (grids(ik,j,1) .eq. 0) then
	    write(6,*)"error possible at rateupdate grids(,,1)=0 kk=",kk
	  endif
	  call neighbor(ik,j,nfuse,nback1)
	  if (grids(ik,j,3) .eq. 1) then
	    NPOS=ik+(j-1)*NBD
	    nhh = mod(NPOS, surfmax)
 8          nhh = nhh + 1
            if(nhh .gt. surfmax) nhh = 1
	    if(nbox(nhh).ne.NPOS)goto 8
	    if (nback1 .eq. 6) then
	      !__clear NPOSrate & ipath & nbox.
              do izz=1, ipath(nhh)
                NPOSrate(nhh,izz) = 0.d0
              enddo
              !__update tree.
              CALL treeupdate(nhh)
	      grids(ik,j,3)=0		!renew jump-atom info.
              ipath(nhh) = 0
              nbox(nhh) = 0
              goto 19
	    else
	      !__a must! the NN relations can be different after jump.
              do izz=1, ipath(nhh)
                NPOSrate(nhh,izz) = 0.d0
              enddo
              CALL treeupdate(nhh)
              ipath(nhh) = 0
	    endif
	  else
	    if (nback1 .eq. 6) goto 19
	    NPOS=ik+(j-1)*NBD
	    nhh = mod(NPOS, surfmax)
 10         nhh = nhh + 1
            if(nhh .gt. surfmax) nhh = 1
	    if (nbox(nhh) .gt. 0) goto 10
	    grids(ik,j,3) = 1
	    ipath(nhh) = 0            !necessary?
	    nbox(nhh) = NPOS	!more in future.
	  endif
	  nc1=nback1
	  do jjj=j-1, j+1
	    iaddl=j-(j/2)*2+(1-abs(jjj-j))*(j-1-((j-1)/2)*2)
            iaddr=j-1-((j-1)/2)*2+(1-abs(jjj-j))*(j-(j/2)*2)
	    do iw=ik-iaddl, ik+iaddr
	      if (iw .lt. 1 .or. iw .gt. iperlen) then
                iii = perlenc1( iw )
              else
                iii = iw
              endif
	      if(grids(iii,jjj,1).ne.0)goto 15
	      nfuse=1
	      call neighbor(iii,jjj,nfuse,nback1)
	      if(nback1.eq.0) goto 15
	      ipath(nhh) = ipath(nhh) + 1
	      if (ipath(nhh) .gt. 4) then
	        write(6,*)"error ipath(nhh)>4 at rateupdate."
	        write(6,*)"error at kk=",kk
	      endif
	      NPOSpath(nhh,ipath(nhh))=iii+(jjj-1)*NBD
	      NPOSrate(nhh,ipath(nhh))=ppb(nc1,nback1)
 15	    enddo
	  enddo
          CALL treeupdate(nhh)
 19	enddo
	return
	end

