!Determines whether a touching particle should be deposited
!using a momentum-dependent scheme
!It also accounts for the "relaxation" of the atom
!The evenness of a layer matters.
!Odd layers follow the form of the initial atomic layer, while even layers fit in the spaces between.
!The Odd layers will stick out further on the left and even layers will stick out further on the right
!The perodic boundary conditions are then somewhat rough in regards to the real x-component and will need
!to take evenness into account.
!Change the program to use the case construct, instead of If statements, using values from coordinationCalc program

subroutine momentumDeposit()

	use globalVariables

!	integer :: coordination = 0
	
	
	!Check for boundary conditions
	if (xIndex == 1)	then
	
		if (evenness > 0) then
			coordination = grid(substrateWidth, yIndex - 1)%occupationNumber + grid(substrateWidth, yIndex)%occupationNumber + &
			grid(substrateWidth, yIndex + 1)%occupationNumber + grid(xIndex, yIndex + 1)%occupationNumber + &
			grid(xIndex + 1, yIndex)%occupationNumber + grid(xIndex, yIndex - 1)%occupationNumber
		else
			coordination = grid(xIndex, yIndex - 1)%occupationNumber + grid(substrateWidth, yIndex)%occupationNumber + &
			grid(xIndex, yIndex + 1)%occupationNumber + grid(xIndex + 1, yIndex + 1)%occupationNumber + &
			grid(xIndex + 1, yIndex)%occupationNumber + grid(xIndex + 1, yIndex - 1)%occupationNumber
		endif
		!If the vapor atom neighbors 2 or more atoms then its stable, otherwise relax it
		if (coordination >= 2) then
		!Problem with grid: its declared in a private subroutine, need to declare it outside
		!and make it allocatable, or declare in a public method
			grid(xIndex, yIndex)%occupationNumber = 1
			deposited = 1
			
			if(yIndex > gridMaxHeight) then				
				gridMaxHeight = yIndex
				print *, 'Two atoms'
			endif
			
		!Check where neighboring atom is and act appropriately	
		else
		
			!Atom to lower left and odd layer
			if	(grid(substrateWidth, yIndex - 1)%occupationNumber == 1) then
				
				if(evenness > 0) then
				
					grid(xIndex, yIndex - 1)%occupationNumber = 1
					deposited = 1
					
					if(yIndex > gridMaxHeight) then				
						gridMaxHeight = yIndex
						print *, 'Bottom left, odd'
					endif
					
				endif
			
			!Atom to lower left or right (depending on layer)
			elseif(grid(xIndex, yIndex -1)%occupationNumber == 1) then
			
				if(evenness > 0) then
					grid(substrateWidth, yIndex - 1)%occupationNumber = 1
				else
					grid(xIndex + 1, yIndex - 1)%occupationNumber = 1
				endif
				deposited = 1
				
				if(yIndex > gridMaxHeight) then
					
						gridMaxHeight = yIndex
						print *, 'Bottom left (even), right (odd)'
					endif
				
			!Atom to lower right and even layer
			elseif (grid(xIndex + 1, yIndex + 1)%occupationNumber == 1) then
				
				if (evenness <= 0) then
					grid(xIndex, yIndex - 1)%occupationNumber = 1
					deposited = 1
					
					if(yIndex > gridMaxHeight) then
					
						gridMaxHeight = yIndex
						print *, 'Bottom right (even)'
					endif
				endif
			
			!This method sucks, need more angular dependence...
			!The atom will most likely just go past the site, unless pointed right at it
			!Check if to right of single atom, cradle if theta > 0, keep moving if theta < 0
			!Theta is incidence angle measured from normal of x-axis
			!I'm starting to think more and more that this situation doesn't matter and shouldn't result in dep.
			!However, it will be good to check how often it happens and make changes if needed
			elseif	(grid(xIndex - 1, yIndex)%occupationNumber == 1)	then
				
!				if	(newAtom%thetaVapor <= 0)	then
!				else
!					!Account for bi-layer index difference
!					if	(evenness > 0) then
!					
!						grid(xIndex - 1, yIndex - 2)%occupationNumber = 1
!					else
!						grid(xIndex - 1, yIndex - 2)%occupationNumber = 1
!					endif
!					deposited = 1
!					
!					if(yIndex > gridMaxHeight) then
!					
!						gridMaxHeight = yIndex
!						print *, 'Grid taller? For Real?'
!					endif
					
				endif
			
			!Opposite situation from above
			elseif (grid(xIndex + 1, yIndex)%occupationNumber == 1)	then
!				
!				if (newAtom%thetaVapor >= 0)	then
!				
!				else
!					!Account for bi-layer
!					if	(evenness > 0) then
!					
!						grid(xIndex + 1, yIndex - 2)%occupationNumber = 1
!					else
!						grid(xIndex + 1, yIndex -2)%occupationNumber = 1
!					endif
!					deposited = 1
!					
!					if(yIndex > gridMaxHeight) then
!					
!						gridMaxHeight = yIndex
!						print *, 'Grid taller? For Real?'
!					endif
				endif
				
			!Check if below single atom, if so just keep going
			!This could have conflicts if the coordination number is not exact (bi-layer stuff)
			elseif (grid(substrateWidth, yIndex + 1)%occupationNumber == 1 .or. grid(xIndex, yIndex + 1)%occupationNumber == 1 .or. &
				grid(xIndex + 1, yIndex + 1)%occupationNumber == 1) then
				print *, 'Went under atom'
			
			endif
		endif
			
	elseif (xIndex == substrateWidth .and. evenness > 0) then
		coordination = grid(xIndex - 1, yIndex - 1)%occupationNumber + grid(xIndex - 1, yIndex)%occupationNumber + &
		grid(xIndex - 1, yIndex + 1)%occupationNumber + grid(xIndex, yIndex + 1)%occupationNumber + &
		grid(1, yIndex)%occupationNumber + grid(xIndex, yIndex - 1)%occupationNumber
		
		
	elseif (xIndex == substrateWidth .and. evenness == 0) then
		coordination = grid(xIndex, yIndex - 1)%occupationNumber + grid(xIndex - 1, yIndex)%occupationNumber + &
		grid(xIndex, yIndex + 1)%occupationNumber + grid(1, yIndex + 1)%occupationNumber + &
		grid(1, yIndex)%occupationNumber + grid(1, yIndex - 1)%occupationNumber
	
	else	
		!If evenness > 0, odd numbered row
		!Calculate number of surrounding atoms
		if (evenness > 0)	then
			coordination = grid(xIndex - 1, yIndex - 1)%occupationNumber + grid(xIndex - 1, yIndex)%occupationNumber + &
			grid(xIndex - 1, yIndex + 1)%occupationNumber + grid(xIndex, yIndex + 1)%occupationNumber + &
			grid(xIndex + 1, yIndex)%occupationNumber + grid(xIndex, yIndex - 1)%occupationNumber
			print *, coordination
		else
			coordination = grid(xIndex, yIndex - 1)%occupationNumber + grid(xIndex - 1, yIndex)%occupationNumber + &
			grid(xIndex, yIndex + 1)%occupationNumber + grid(xIndex + 1, yIndex + 1)%occupationNumber + &
			grid(xIndex + 1, yIndex)%occupationNumber + grid(xIndex + 1, yIndex - 1)%occupationNumber
	!		print *, coordination
		endif
		
		!If the vapor atom neighbors 2 or more atoms then its stable, otherwise relax it
		if (coordination >= 2) then
		!Problem with grid: its declared in a private subroutine, need to declare it outside
		!and make it allocatable, or declare in a public method
			grid(xIndex, yIndex)%occupationNumber = 1
			deposited = 1
			
			if(yIndex > gridMaxHeight) then				
				gridMaxHeight = yIndex
				print *, 'Two atoms'
			endif
			
		!Check where neighboring atom is and act appropriately	
		else
		
			select case (singleNeighborLocation)
			
				case (1)		
					grid(xIndex + oddIndex + boundaryConditionModifier , yIndex - 1)%occupationNumber = 1
					deposited = 1
				case (2)
					print *, 'To right, continuing...'
				case (3:4)
					print *, 'Below, continuing'
				case (5)
					print *, 'To left, continuing'
				case (6)
					grid(xIndex - evenIndex + boudaryConditionModifier, yIndex - 1)%occupationNumber = 1
					deposited = 1
				case default
					print *, 'Case select error, uh oh'
			end select
			
			if (deposited == 1 .and. yIndex > gridMaxHeight) then
				gridMaxHeight = yIndex
			endif
			!Atom to lower left and odd layer
			if	(grid(xIndex - 1, yIndex - 1)%occupationNumber == 1) then
				
				if(evenness > 0) then
				
					grid(xIndex, yIndex - 1)%occupationNumber = 1
					deposited = 1
					
					if(yIndex > gridMaxHeight) then				
						gridMaxHeight = yIndex
						print *, 'Bottom left, odd'
					endif
					
				endif
			
			!Atom to lower left or right (depending on layer)
			elseif(grid(xIndex, yIndex -1)%occupationNumber == 1) then
			
				if(evenness > 0) then
					grid( xIndex - 1, yIndex - 1)%occupationNumber = 1
				else
					grid(xIndex + 1, yIndex - 1)%occupationNumber = 1
				endif
				deposited = 1
				
				if(yIndex > gridMaxHeight) then
					
						gridMaxHeight = yIndex
						print *, 'Bottom left (even), right (odd)'
					endif
				
			!Atom to lower right and even layer
			elseif (grid(xIndex + 1, yIndex + 1)%occupationNumber == 1) then
				
				if (evenness <= 0) then
					grid(xIndex, yIndex - 1)%occupationNumber = 1
					deposited = 1
					
					if(yIndex > gridMaxHeight) then
					
						gridMaxHeight = yIndex
						print *, 'Bottom right (even)'
					endif
				endif
			
			!Check if to right of single atom, cradle if theta > 0, keep moving if theta < 0
			!Theta is incidence angle measured from normal of x-axis
			elseif	(grid(xIndex - 1, yIndex)%occupationNumber == 1)	then
				
				if	(newAtom%thetaVapor <= 0)	then
				else
					!Account for bi-layer index difference
					if	(evenness > 0) then
					
						grid(xIndex - 1, yIndex - 2)%occupationNumber = 1
					else
						grid(xIndex - 1, yIndex - 2)%occupationNumber = 1
					endif
					deposited = 1
					
					if(yIndex > gridMaxHeight) then
					
						gridMaxHeight = yIndex
						print *, 'Grid taller? For Real?'
					endif
					
				endif
			
			!Opposite situation from above
			elseif (grid(xIndex + 1, yIndex)%occupationNumber == 1)	then
				
				if (newAtom%thetaVapor >= 0)	then
				
				else
					!Account for bi-layer
					if	(evenness > 0) then
					
						grid(xIndex + 1, yIndex - 2)%occupationNumber = 1
					else
						grid(xIndex + 1, yIndex -2)%occupationNumber = 1
					endif
					deposited = 1
					
					if(yIndex > gridMaxHeight) then
					
						gridMaxHeight = yIndex
						print *, 'Grid taller? For Real?'
					endif
				endif
				
			!Check if below single atom, if so just keep going
			!This could have conflicts if the coordination number is not exact (bi-layer stuff)
			elseif (grid(xIndex - 1, yIndex + 1)%occupationNumber == 1 .or. grid(xIndex, yIndex + 1)%occupationNumber == 1 .or. &
				grid(xIndex + 1, yIndex + 1)%occupationNumber == 1) then
				print *, 'Went under atom'
			
			endif
		endif	
	endif
	
	if deposited == 1
end subroutine momentumDeposit
		