!Determines whether a touching particle should be deposited
!using a momentum-dependent scheme
!It also accounts for the "relaxation" of the atom
!The evenness of a layer matters.
!Odd layers follow the form of the initial atomic layer, while even layers fit in the spaces between.
!The Odd layers will stick out further on the left and even layers will stick out further on the right
!The perodic boundary conditions are then somewhat rough in regards to the real x-component and will need
!to take evenness into account.
!Change the program to use the case construct, instead of If statements, using values from coordinationCalc program
!
module momentumDepositTool
	
	use globalVariables
	use coordinationHelpers
	use indexConversion
	public momentumDeposit
	
	contains
	function momentumDeposit(xIndex, yIndex, nextXIndex, nextYIndex) result (deposited)

		!All of these declared in global variables.  May want to compartmentalize more in the future.
	!	integer, intent(in) :: xIndex, yIndex, xVapor, thetaVapor, boundaryConditionModifier, evenIndex, oddIndex, coordination &
	!		singleNeighborLocation
	!	integer, intent(out) :: deposited
		real :: nextXSpot
		real :: realXIndex
		integer :: nextXIndex, nextYIndex, depositedXIndex, depositedYIndex, evenness, oddness
		integer :: xIndex, yIndex, deposited, coordination
		nextXSpot = 0.0
		realXIndex = 0.0
		singleNeighborLocation = 0
		deposited = 0
	!	print *, 'Beginning momentumDeposit'
		!If the vapor atom neighbors 2 or more atoms then its stable, otherwise relax it
		coordination = CoordinationCalculation(xIndex, yIndex)
		print * ,xIndex, yIndex, nextXIndex, nextYIndex, movieIndex, coordination

		if (coordination >= 2 .and. grid(nextXIndex, nextYIndex)%occupationNumber == 1) then
	!		print *, 'Two atoms'
			!The next line is wrong, did I forget to set up the grid or something?
			!This line might be ok, but its yIndex is starting out at zero, which is way bad
			if (grid(xIndex, yIndex)%occupationNumber == 1) then
				print *, 'Error: overwriting existing point 1', xIndex, yIndex, nextXindex, nextYIndex, movieIndex
			endif
			grid(xIndex, yIndex)%occupationNumber = 1
			deposited = 1
			depositedXIndex = xIndex
			depositedYIndex = yIndex
	
			!Update the jumpTree and the maximum height.
			call depositionUpdate(depositedXIndex, depositedYIndex)
			if(yIndex > gridMaxHeight) then				
				gridMaxHeight = yIndex
				print *, 'new Max ', gridMaxHeight 
			endif
		elseif (coordination == 1 .and. grid(nextXIndex, nextYIndex)%occupationNumber == 1) then		
		!Check where neighboring atom is and act appropriately
		!This is a simplified version of single neighbor deposition
		!Ignores situations where the neighbor atom is below or beside an atom
		!Only deposits in two possible configurations, the side-by-side situations may need to be accounted for
		
			if (mod(yIndex,2) == 0) then
				evenness = 1
				oddness = 0
			else
				evenness = 0
				oddness  = 1
			endif
			
			singleNeighborLocation = singleNeighborFinder(xIndex, yIndex)
			select case (singleNeighborLocation)
			
				case (1)
					print *, 'Deposit Case 1'
					if (grid(boundaryConditionChecker(xIndex + evenness), yIndex - 1)%occupationNumber == 1) then
						print *, 'Error: overwriting existing point 2', xIndex, yIndex, nextXindex, nextYIndex, movieIndex
					elseif(coordinationCalculation(boundaryConditionChecker(xIndex + evenness), yIndex - 1) == 1) then
						grid(boundaryConditionChecker(xIndex - 1), yIndex)%occupationNumber = 1
						deposited = 1
						depositedXIndex = boundaryConditionChecker(xIndex - 1)
						depositedYIndex = yIndex
						print *, 'Preventing overhang! 1'
					else
						grid(boundaryConditionChecker(xIndex + evenness), yIndex - 1)%occupationNumber = 1
						deposited = 1
						depositedXIndex = boundaryConditionChecker(xIndex + evenness)
						depositedYIndex = yIndex -1
						!call depositionUpdate(depositedXIndex, depositedYIndex)
					endif
				case (2)
					print *, 'Deposit Case 2, this needs addressed', movieIndex
					if (grid(boundaryConditionChecker(xIndex -1 -oddness), yIndex - 1)%occupationNumber == 1) then
						if (grid(boundaryConditionChecker(xIndex -oddness), yIndex -1)%occupationNumber /= 1) then
							deposited = 1
							depositedXIndex = boundaryConditionChecker(xIndex -oddness)
							depositedYIndex = yIndex -1
							grid(depositedXIndex, depositedYIndex)%occupationNumber = 1
						else
							print *, 'Error: overwriting existing point 2',xIndex, yIndex, nextXindex, nextYIndex, movieIndex
						endif
					elseif(grid(boundaryConditionChecker(xIndex -1 -oddness), yIndex -1)%occupationNumber /= 1) then
						deposited = 1
						depositedXIndex = boundaryConditionChecker(xIndex -oddness -1)
						depositedYIndex = yIndex -1
						grid(depositedXIndex,depositedYIndex)%occupationNumber = 1
					else
						print *, 'Error just trying to deal with this guy to the left', xIndex, yIndex, movieIndex
					endif
				case (3:4)
					print *, 'Deposit Case 3-4', movieIndex
					!print *, 'Below, continuing', atomCount
				case (5)
					print *, 'Deposit Case 5, this needs addressed', movieIndex
					if (grid(boundaryConditionChecker(xIndex +1 +evenness), yIndex - 1)%occupationNumber == 1) then
						if (grid(boundaryConditionChecker(xIndex +evenness), yIndex -1)%occupationNumber /= 1) then
							deposited = 1
							depositedXIndex = boundaryConditionChecker(xIndex +evenness)
							depositedYIndex = yIndex -1
							grid(depositedXIndex, depositedYIndex)%occupationNumber = 1
						else
							print *, 'Error: overwriting existing point 2',xIndex, yIndex, nextXindex, nextYIndex, movieIndex
						endif
					elseif(grid(boundaryConditionChecker(xIndex +1 +evenness), yIndex -1)%occupationNumber /= 1) then
						deposited = 1
						depositedXIndex = boundaryConditionChecker(xIndex +evenness +1)
						depositedYIndex = yIndex -1
						grid(depositedXIndex,depositedYIndex)%occupationNumber = 1
					else
						print *, 'Error just trying to deal with this guy to the right', xIndex, yIndex, movieIndex
					endif
				!This is a problem, as atoms will be deposited whether 
				case (6)
					print *, 'Deposit Case 6'
					if (grid(boundaryConditionChecker(xIndex - oddness), yIndex - 1)%occupationNumber == 1) then
						print *, 'Error: overwriting existing point 2', xIndex, yIndex, nextXindex, nextYIndex, movieIndex
					elseif(coordinationCalculation(boundaryConditionChecker(xIndex - oddness), yIndex - 1)==1) then
						grid(boundaryConditionChecker(xIndex +1), yIndex)%occupationNumber = 1
						deposited = 1
						depositedXIndex = boundaryConditionChecker(xIndex +1)
						depositedYIndex = yIndex
						print *, 'Preventing overhang! 6'
					else
						grid(boundaryConditionChecker(xIndex - oddness), yIndex - 1)%occupationNumber = 1
						deposited = 1
						depositedXIndex = boundaryConditionChecker(xIndex - oddness)
						depositedYIndex = yIndex -1
					!	call depositionUpdate(depositedXIndex, depositedYIndex)
					endif
				case default
					print *, 'Case select error, uh oh', movieIndex, singleNeighborLocation
			end select
			
			!Update the binary tree information
			if (deposited == 1) then
				!print *, 'Calling depositionUpdate'
				call depositionUpdate(depositedXIndex, depositedYIndex)
			endif
	!		print *, 'got closer'
			if (deposited == 1 .and. depositedYIndex > gridMaxHeight) then
				gridMaxHeight = depositedYIndex
				!print *, 'new Max ', gridMaxHeight
			endif
	!		print *, 'got even closer'
		elseif ( grid(nextXIndex, nextYIndex)%occupationNumber == 1) then
			print *, 'Coordination does not match', coordination,singleNeighborLocation,nextXIndex, nextYIndex&
			, movieIndex, xIndex, yIndex, deposited, grid(nextXIndex, nextYIndex)%occupationNumber
		endif	
	!	print *, 'Made through print'
		!Update the movieGrid
		if (movieIndex < movieIndexMax .and. deposited ==1) then
			movieIndex = movieIndex + 1
			movieGrid(depositedXIndex, depositedYIndex, movieIndex:movieIndexMax) = 1
		!	print *, 'momentumDeposit movieGrid'
		endif
	!	print *, 'It made through whole subroutine'
	end function momentumDeposit
end module momentumDepositTool