	!Theron Rodgers 5/25/11
!Subroutine to output the deposited lattice.  Outputs 1 for filled site and 0 for empty.
!Will print from bottom to top
!Will be useful to add code to calculate the porosity
!
!Variables
! i, grid(:,:), substrateWidth, gridMaxHeight
!
!Modules & subroutines
!globalVariables
subroutine output()

	use globalVariables
	integer :: i, j,k, outputMax
	real :: density, occupiedCount, diffusionAverage
	real, dimension(1,2) :: positions
	character(1024) :: outputName, gridName
!	print *, grid(:,:)%occupationNumber
	!We should change output to create files according to the current step number
	!Write the desired fileName to character variable
	write(outputName, "(A,I0,A)") "kmcOut", 45*(loopIndex-1), ".txt"
	print *, trim(outputName), outputName
	write(gridName,"(A,I0,A)") "grid",45*(loopIndex-1), ".csv"
	open (unit=12, file = trim(gridName), status = 'replace')
	open (unit=14, file = trim(outputName), status = 'replace')
	open (unit = 16, file = "movie.csv", status = 'replace')
	
	outputMax = substrateWidth * gridMaxHeight
	occupiedCount = 0
	diffusionAverage = numberOfDiffusions/atomsToDeposit
	print *, 'Average number of jumps', diffusionAverage
!	print *, grid(:,:)%occupationNumber
	
	!Go to each lattice site and write the coordinates and occupationNumber
	!It would probably be useful to output the real-valued coordinates, rather than integer site numbers
	do i = 1, substrateWidth
		do j = 1, gridMaxHeight
!			print *, grid(j,i)%occupationNumber
			if (mod(j,2) == 0)	then
				k = i +1/2
			else
				k = i
			endif
			
			
			positions(1,1) = k*deltaXGrid
			positions(1,2) = j*deltaYGrid
			
			!Find the density
			if (j > numberOfInitialLayers) then
				
				if (grid(i,j)%occupationNumber == 1) then
					
					occupiedCount = occupiedCount + 1
				endif
			endif

			write(unit = 12, fmt = *), positions(1,1), ',', positions(1,2),',', grid(i,j)%occupationNumber

		enddo
	enddo
	
	density = occupiedCount / outputMax
	
	print *, 'The resulting density is', density, occupiedCount, outputMax
	close(12)
	call CPU_TIME(finish)
	
	print *, 'CPU time ', finish-start, 'gridMaxHeight', gridMaxHeight
		
!This will be the easiest way to resume the script.
	do i = 1, gridMaxHeight
	
		write (unit = 14, fmt = *), grid(1:substrateWidth, gridMaxHeight - i + 1)%occupationNumber
		
	enddo
	close(14)
	!Output the movie file for the desired number of steps
	!This will output three columns of information, color, x, y
	if(movieIndexMax > 1) then
		do k = 1, movieIndex
			do i = 1, substrateWidth
				do j = 1, gridMaxHeight
						write(unit = 16, fmt = *), movieGrid(i,j,k), i,j
				enddo
			enddo
	!		write (unit = 16, fmt = *), -10, 1, 1
		enddo
	endif
			
	
	
	close(16)
end subroutine output