!Determine the exact location to deposit the vapor atom.
!Need to account for situations where the atom would be deposited above or below the site with a coordination of 1
!This doesn't work, and we should deposit to whichever side has the higher coordination.
subroutine stickSiteFinder(vaporCoords, siteCoords)

	use globalVariables
	use indexConversion
	use coordinationHelpers
	
	real, dimension(2), intent(in) :: siteCoords
	real, dimension(2), intent(in) :: vaporCoords
	integer, dimension(2) :: intSiteCoords

	!Don't know if oddModifier will be an integer or real here.
	integer :: oddModifier, xDeposit, yDeposit
	real :: evenModifier
	
	!print *, 'starting stickSiteFinder', vaporCoords, siteCoords
	!First check if the vapor atom is left or right of the site.
	!Need to add boundary compliance, which we do through multiBCC
	!NEED to account for even/odd rows, which we do through oddModifier
	if (mod(NINT(siteCoords(2)),2) > 0)	then
			oddModifier = 1
			evenModifier = 0
		else
			oddModifier = 0
			evenModifier = .5
	endif
	
	intSiteCoords(1) = NINT(siteCoords(1) - evenModifier)
	intSiteCoords(2) = NINT(siteCoords(2))
	!print *, 'intSiteCoords', intSiteCoords
	
	xDeposit = 0
	yDeposit = 0
		
	!Check if vapor atom is to left or right of the site's center
	!Need to also account for the coordination of the same-row sites left & right of the siteCoords
	!The sites a row above or below should always be valid locations, but the next one may not
	!Need to account for when the site is on the edge with only 2 neighbor atoms, we should try
	!to deposit above and left
	if(vaporCoords(1)-siteCoords(1)<0) then
		!print *, 'vapor < siteCoords x'
		!Check if the atom is above or below the y-midpoint at clashtime
		if(vaporCoords(2) - siteCoords(2) > 0) then
			!print *, 'vapor > siteCoords y'
			!Check if the site next too the deposition one is not occupied, and not on its own.
			if (grid(multiBCC((intSiteCoords(1)-1)),intSiteCoords(2))&
			%occupationNumber /= 1 .and. coordinationCalculation(multiBCC((&
			intSiteCoords(1)-1)),intSiteCoords(2)) > 1) then
				xDeposit = multiBCC(intSiteCoords(1)-1)
				yDeposit = intSiteCoords(2)
				!print *, 'Deposit 1'
			elseif(grid(multiBCC(intSiteCoords(1)-oddModifier),intSiteCoords(2)+1)&
			%occupationNumber/= 1 .and. coordinationCalculation(multiBCC((intSiteCoords&
			(1)-oddModifier)),intSiteCoords(2)+1) > 1) then
				!Deposit above lefts
				xDeposit = multiBCC((intSiteCoords(1)-oddModifier))
				yDeposit = intSiteCoords(2) +1 
				!print *, 'Deposit 2'
			elseif(grid(multiBCC(intSiteCoords(1) + 1 - oddModifier),intSiteCoords(2) + &
			1)%occupationNumber /= 1 .and. coordinationCalculation(multiBCC(intSiteCoords(1) + 1 - oddModifier)&
			,intSiteCoords(2) + 1) > 1) then
				!Deposit above right
				xDeposit = multiBCC((intSiteCoords(1) + 1 - oddModifier))
				yDeposit = intSiteCoords(2) + 1
				!print *, 'Deposit 2-1'
			else
				print *, 'Error Deposit 2', grid(multiBCC((intSiteCoords(1)-oddModifier)&
				),intSiteCoords(2)+1)%occupationNumber, coordinationCalculation&
				(multiBCC((intSiteCoords(1)-oddModifier)),intSiteCoords(2)+1)
				print *, multiBCC((intSiteCoords(1)-oddModifier))
				print *, intSiteCoords(2) + 1
				print *, coordinationCalculation(intSiteCoords(1), intSiteCoords(2))
				print *, grid(intSiteCoords(1), intSiteCoords(2))%occupationNumber
				print *, REAL(depositionFlux(atomCount,2))
			endif
		else
			!print *, 'vapor < siteCoords y'
			if (grid(multiBCC((intSiteCoords(1)-1)),&
			intSiteCoords(2))%occupationNumber /= 1 .and. coordinationCalculation(multiBCC&
			((intSiteCoords(1)-1)),intSiteCoords(2)) > 1) then
				xDeposit = multiBCC((intSiteCoords(1)-1))
				yDeposit = intSiteCoords(2)
				!print *, 'Deposit 3'
			elseif(grid(multiBCC((intSiteCoords(1)-oddModifier)),intSiteCoords(2)-1)&
			%occupationNumber/= 1 .and. coordinationCalculation(multiBCC((intSiteCoords(1)-oddModifier)&
			),intSiteCoords(2)-1) >1) then
				!Deposit below left
				xDeposit = multiBCC((intSiteCoords(1)-oddModifier))
				yDeposit = intSiteCoords(2)-1
				!print *, 'Deposit 4'
			elseif(grid(multiBCC(intSiteCoords(1)+1-oddModifier), intSiteCoords(2)-1)%occupationNumber&
			/= 1 .and. coordinationCalculation(multiBCC(intSiteCoords(1)+1-oddModifier),intSiteCoords(2)-1)>1) then
				!Deposit below right
				xDeposit = multiBCC((intSiteCoords(1) +1 -oddModifier))
				yDeposit = intSiteCoords(2) -1
				!print *, 'Deposit 4-1'
			else
				print *, 'Error Deposit 4', grid(multiBCC((intSiteCoords(1)-oddModifier))&
				,intSiteCoords(2)-1)%occupationNumber, coordinationCalculation(multiBCC&
				((intSiteCoords(1)-oddModifier)),intSiteCoords(2)-1)
				print *, multiBCC((intSiteCoords(1)-oddModifier))
				print *, intSiteCoords(2) - 1
				print *, grid(multiBCC(intSiteCoords(1)),intSiteCoords(2))%occupationNumber
				print *, coordinationCalculation(multiBCC(intSiteCoords(1)),intSiteCoords(2))
				print *, grid(multiBCC(intSiteCoords(1)-1),intSiteCoords(2))%occupationNumber
				print *, coordinationCalculation(multiBCC(intSiteCoords(1)-1),intSiteCoords(2))
				print *, REAL(depositionFlux(atomCount,2))
			endif
		endif
	!Deposit atom to the right
	else
		!print *, 'vapor > siteCoords x'
		!Check if the atom is above or below the y-midpoint at clashtime
		if(vaporCoords(2) - siteCoords(2) > 0) then
			!print *, 'vapor > siteCoords y'
			!Check if the site next too the deposition one is occupied.  If it is, deposit above.
			if (grid(multiBCC((intSiteCoords(1)+1))&
			,intSiteCoords(2))%occupationNumber /= 1 .and. coordinationCalculation(multiBCC&
			((intSiteCoords(1)+1)),intSiteCoords(2)) > 1) then
				
				xDeposit = multiBCC((intSiteCoords(1) +1))
				yDeposit = intSiteCoords(2)
			!	print *, 'Deposit 5'
			elseif(grid(multiBCC(intSiteCoords(1) + 1 - oddModifier),intSiteCoords(2) + &
			1)%occupationNumber /= 1 .and. coordinationCalculation(multiBCC(intSiteCoords(1) + 1 - oddModifier)&
			,intSiteCoords(2) + 1) > 1) then
				!Deposit above right
				xDeposit = multiBCC((intSiteCoords(1) + 1 - oddModifier))
				yDeposit = intSiteCoords(2) + 1
			!	print *, 'Deposit 6'
			elseif(grid(multiBCC(intSiteCoords(1)-oddModifier),intSiteCoords(2)+1)&
			%occupationNumber/= 1 .and. coordinationCalculation(multiBCC((intSiteCoords&
			(1)-oddModifier)),intSiteCoords(2)+1) > 1) then
				!Deposit above lefts
				xDeposit = multiBCC((intSiteCoords(1)-oddModifier))
				yDeposit = intSiteCoords(2) +1 
			!	print *, 'Deposit 6-1'
			else
				print *, 'Error Deposit 6', grid(multiBCC((intSiteCoords(1) + 1 - oddModifier))&
				,intSiteCoords(2) + 1)%occupationNumber , coordinationCalculation(multiBCC&
				((intSiteCoords(1) + 1 - oddModifier)),intSiteCoords(2) + 1)
	
				print *, multiBCC((intSiteCoords(1) + 1 - oddModifier))
				print *, intSiteCoords(2) + 1
				print *, grid(multiBCC(intSiteCoords(1) + 1), intSiteCoords(2))%occupationNumber
				print *, coordinationCalculation(multiBCC(intSiteCoords(1)+1),intSiteCoords(2))
				print *, REAL(depositionFlux(atomCount,2))
			endif
		else
			!print *, 'vapor < intSiteCoords y'
			if (grid(multiBCC((intSiteCoords(1)+1)),intSiteCoords(2))%occupationNumber /= 1&
			.and. coordinationCalculation(multiBCC((intSiteCoords(1)+1)),intSiteCoords(2)) > 1) then
				xDeposit = multiBCC((intSiteCoords(1) +1))
				yDeposit = intSiteCoords(2)
		!		print *, 'Deposit 7'
			elseif(grid(multiBCC(intSiteCoords(1)+1-oddModifier), intSiteCoords(2)-1)%occupationNumber&
			/= 1 .and. coordinationCalculation(multiBCC(intSiteCoords(1)+1-oddModifier),intSiteCoords(2)-1)>1) then
				!Deposit below right
				xDeposit = multiBCC((intSiteCoords(1) +1 -oddModifier))
				yDeposit = intSiteCoords(2) -1
		!		print *, 'Deposit 8'
			elseif(grid(multiBCC((intSiteCoords(1)-oddModifier)),intSiteCoords(2)-1)&
			%occupationNumber/= 1 .and. coordinationCalculation(multiBCC((intSiteCoords(1)-oddModifier)&
			),intSiteCoords(2)-1) >1) then
				!Deposit below left
				xDeposit = multiBCC((intSiteCoords(1)-oddModifier))
				yDeposit = intSiteCoords(2)-1
		!		print *, 'Deposit 8-1'
			else
				print *, 'Error Deposit 8'
				print *, multiBCC(intSiteCoords(1) +1), intSiteCoords(2)
			endif
		endif
	endif
	
	grid(xDeposit,yDeposit)%occupationNumber = 1
	call depositionUpdate(xDeposit,yDeposit)
!	print *, 'Atom deposited at', xDeposit, yDeposit, coordinationCalculation(xDeposit,yDeposit)
	
	if(yDeposit > gridMaxHeight) then
		gridMaxHeight = yDeposit
		print *, 'new Max ', gridMaxHeight
	endif
	
end subroutine stickSiteFinder