!New version of xVaporCalculator
!Will find the floating-point X position and the corresponding closest grid point.
!Will store both values and use the Float version to perform calculations
!Will account for the boundary conditions and their depence on even & odd rows
!Will let x position run continuously, but place it into the simulation area when snapping to grid
!The key points: We are moving very small increments at a time, so its important to keep as accurate an x-value as
!possible, until the very last moment.  This is the only way to simulate the true effects of the Incident angle
!
!Variables
!i, realXIndex, newAtom, deltaYGrid, deltaXGrid, evenness
!
!Modules & subroutines
!globalVariables, 
!Make a function which only returns the new xIndex, find yIndex separately
module xVaporCalc
	use globalVariables
	use coordinationHelpers
	public ::xVaporCalculator
	
	contains
	function xVaporCalculator(xVaporLocal, yVaporLocal, thetaVaporLocal) result(xIndexes)
		!May not want to use global variables
		
		real :: xVaporLocal, thetaVaporLocal
!		integer :: i = 1
		integer :: xIndexLocal, oddMod, yVaporLocal
		real :: realXIndex
		real, dimension(1,2) :: xIndexes
		realXIndex = 0.0
		!Calculate new x-position with fixed deltaY	
		!ACOS(0.0) evaluates to Pi, this seems like the easiest way :/
		!This formula is evaluating to far too small a value, it seems like its being passed zero *wrong*
		!print *, 'X before movement', xVaporLocal
		xVaporLocal = TAN(thetaVaporLocal*ACOS(0.0)/180) * deltaYGrid/deltaXGrid + xVaporLocal
		xIndexes(1,1) = xVaporLocal

		!Set the odd Modifier
		if (mod(yVaporLocal,2) /= 0) then
			oddMod = 1
		else
			oddMod = 0
		endif
		
		!Check for the boundary and account for row even/oddness
		realXIndex = xVaporLocal
		xIndexes(1,2) = boundaryConditionChecker(NINT(realXIndex) + oddMod)
	!	print *, 'xIndex', xIndex, realXIndex, yIndex
	end function xVaporCalculator
end module xVaporCalc