!New version of xVaporCalculator
!Will find the floating-point X position and the corresponding closest grid point.
!Will store both values and use the Float version to perform calculations
!Will account for the boundary conditions and their depence on even & odd rows
!Will let x position run continuously, but place it into the simulation area when snapping to grid
!The key points: We are moving very small increments at a time, so its important to keep as accurate an x-value as
!possible, until the very last moment.  This is the only way to simulate the true effects of the Incident angle
!
!Variables
!i, realXIndex, newAtom, deltaYGrid, deltaXGrid, evenness
!
!Modules & subroutines
!globalVariables, 
!Make a function which only returns the new xIndex, find yIndex separately
module xVaporCalc
	use globalVariables
	public ::xVaporCalculator
	
	contains
	function xVaporCalculator(xVaporLocal, thetaVaporLocal) result(realXIndex,xIndexLocal)
		!May not want to use global variables
		
		real :: xVaporLocal, thetaVaporLocal
		integer :: i = 1
		integer :: xIndexLocal
		real :: realXIndex
		!Calculate new x-position with fixed deltaY	
		!ACOS(0.0) evaluates to Pi, this seems like the easiest way :/
		!This formula is evaluating to far too small a value, it seems like its being passed zero *wrong*
	!	print *, 'X before movement', xVaporLocal
		xVaporLocal = TAN(thetaVaporLocal*ACOS(0.0)/180) * deltaYGrid + xVaporLocal
	!	print *, 'X after movement', xVaporLocal
		!Account for atom going out of bounds
		!We need ot account for the vapor possibly going many widths away during the first deposit
		!Execute recursively until within region
	!	do
	!		print *, 'Number of loops around', i
	!		if (xVaporLocal > substrateWidth * deltaXGrid) then
	!			
	!			xVaporLocal = xVaporLocal - substrateWidth * deltaXGrid
	!			
	!		else if (xVaporLocal < 0.0) then
	!			
	!			xVaporLocal = xVaporLocal + substrateWidth * deltaXGrid
	!		else
	!			exit
	!		end if
	!		i = i + 1
	!	enddo
	!	print *, 'X Position is', xVaporLocal
	!	print *, xVaporLocal
		!Need to check evenness condtion and for wrapping
		
		if (evenness > 0) then
			realXIndex = xVaporLocal / deltaXGrid
			xIndexLocal = NINT(realXIndex) + 1
		else
			realXIndex = xVaporLocal / deltaXGrid
			xIndexLocal = CEILING(realXIndex)
		endif
!		if (xIndexLocal < 1) then
!			xIndexLocal = substrateWidth - xIndexLocal
!		elseif (xIndexLocal > substrateWidth) then
!			xIndexLocal = xIndexLocal - substrateWidth
!		endif
	!	print *, 'xIndex', xIndex, realXIndex, yIndex
	end function xVaporCalculator
end module xVaporCalc