function[meanS, meanP, meanZ, stdS, stdP,stdZ, PSobelF, PCannyF, PprewittF] = imageAngleFinder(imageName)

%Load in the original image
Image = imread(imageName);

%resize the image to make things faster and make columns stick out more.
 ImageJ = imresize(Image, 0.05);

%Other corner (416,294), crop to the useful part of the figure (avoid the
%boundaries)
ImageCrop = imcrop(ImageJ, [68,200,348,100]);

ImageBW = im2bw(ImageCrop,.4);
figure(1), imshow(ImageBW), hold on;


sobel = edge(ImageBW,'sobel');
canny = edge(ImageBW,'canny');
prewitt = edge(ImageBW,'prewitt');

[HSobel, thetaSobel, rhoSobel] = hough(sobel);
[HCanny, thetaCanny, rhoCanny] = hough(canny);
[Hprewitt, thetaprewitt, rhoprewitt] = hough(prewitt);
%, 'threshold', ceil(0.3*max(HSobel(:)))

PSobel = houghpeaks(HSobel,4);
PCanny = houghpeaks(HCanny,4);
Pprewitt = houghpeaks(Hprewitt,4);


PSobelF =PSobel(:,2) - 90;
PCannyF =PCanny(:,2) - 90;
PprewittF =Pprewitt(:,2) - 90;


linesC = houghlines(canny,thetaCanny,rhoCanny,PCanny);
linesS = houghlines(sobel,thetaSobel,rhoSobel,PSobel,'FillGap',1,'MinLength',15);
linesP = houghlines(prewitt,thetaprewitt,rhoprewitt,Pprewitt,'FillGap',2,'MinLength',7.5);

for k = 1:length(linesP)
   xy = [linesP(k).point1; linesP(k).point2];
   plot(xy(:,1),xy(:,2),'LineWidth',2,'Color','green');

   % Plot beginnings and ends of lines
   plot(xy(1,1),xy(1,2),'x','LineWidth',2,'Color','yellow')
   plot(xy(2,1),xy(2,2),'x','LineWidth',2,'Color','red');
end


meanS = mean(PSobelF);
meanP = mean(PCannyF);
meanZ = mean(PprewittF);
stdS = std(PSobelF);
stdP = std(PCannyF);
stdZ = std(PprewittF);
end