function[results] = loopAngleFinder(firstRegion, lastRegion, folderType, skipRegions)

close all
length = lastRegion-firstRegion+1;
results = zeros([length, 6]);
j = firstRegion;
for i = 1:length
    
    if (j == skipRegions)
        results(j,:) = results(j-1,:);
    else
        cd([num2str(j),folderType]);
        [meanS, meanC,meanP, stdS, stdC,stdP, SobelF, CannyF,PreWittF] = imageAngleFinder('gridMod2.png');

        results(i,:) = [meanS, meanC, meanP, stdS, stdC, stdP];
        cd ../;
    end   
    j = j+1;
end

figure(3);

scatter(firstRegion:lastRegion,results(1:length,1),'fill');
hold all;
%plot(1:numberOfRegions,results(:,2));
scatter(firstRegion:lastRegion,results(1:length,2),'fill');
scatter(firstRegion:lastRegion,results(1:length,3),'fill');
legend('Sobel', 'Canny','Prewitt');

figure(4);
scatter(firstRegion:lastRegion,results(1:length,4),'fill');
hold all;
%plot(1:numberOfRegions,results(:,5));
scatter(firstRegion:lastRegion,results(1:length,6),'fill');
legend('Sobel', 'Prewitt');

for i = 1:length
    if(results(i,4) > results(i,6))
        if(results(i,5) > results(i,6) && results(i,3) ~= -89)
            minDevResults(i) = results(i,3);
        else
            minDevResults(i) = results(i,2);
        end
    else
        if(results(i,5) > results(i,4) && results(i,1) ~= -89)
            minDevResults(i) = results(i,1);
        else
            minDevResults(i) = results(i,2);
        end
    end
    if(int8(minDevResults(i)) == -89)
        minDevResults(i) = results(i,1);
    end
end

%minDevResults(:) = results(:,3);

smoothResults = smooth(minDevResults,7,'rlowess');
results(:,8) = smoothResults;

figure(5);
set(gcf,'PaperPositionMode','manual');
set(gcf,'PaperUnits','centimeters');
set(gcf,'PaperPosition',[1 1 9.573 7.54055]);
scatter((firstRegion:lastRegion)*1.07,minDevResults(:),'fill');
hold all;
plot((firstRegion:lastRegion)*1.07,smoothResults,'LineWidth',2);
results(:,7) = minDevResults;
xlabel('Distance from leading edge (mm)');
ylabel('Columnar growth angle');
set(findall(gcf,'type','text'),'fontSize',10)
%export_fig test.pdf

end