function[porosity, columnPore,innerColumnPore, totalPorosity] = porosityFinder(inputFile, substrateWidth, deltaY)
%Read in the grid data and calculate the density in the 80% region of the
%substrate.

close all;
hold off;

%Read in the 3-column (x,y,occupation) input file
%grid = csvread(inputFile);

fileID = fopen(inputFile);
grid = textscan(fileID, '%f %f %f','delimiter',',','CollectOutput',1);
fclose(fileID);

[m,n] = size(grid{1});

gridSize = m;

gridHeightInt = round(gridSize/substrateWidth)
gridHeight = gridHeightInt*deltaY;

j =0;
atomTotal = 0;
columnPorosity = 0;
innerColumnPorosity = 0;
%gridMeasured = zeros([round(m*.6),3]);
%Get the data between 20% and 80% of the grid height.
for i = round(gridSize*.19):round(gridSize*.81)

    if grid{1}(i,2) > gridHeight*.2 && grid{1}(i,2) < gridHeight*.8
        %gridMeasured(j,:) = grid{1}(i,:);
        j = j+1;
        %if j == 2
        %    firstIndex = i-1;
        %end
        
        if round(grid{1}(i,3)) == 1
            atomTotal = atomTotal + 1;
        else
            sumUp = 0;
            sumDown = 0;
            sumLeft = 0;
            sumRight = 0;
            
            for k = 1:35
                sumUp = sumUp + grid{1}(i+k,3);
                sumDown = sumDown + grid{1}(i -k, 3);
                if (i-k*gridHeightInt < 1)
                    sumLeft = sumLeft + grid{1}(gridSize+(i-k*(gridHeightInt)),3);    
                else
                    sumLeft = sumLeft + grid{1}(i-k*gridHeightInt,3);
                end
                
                
                if (i+k*(gridHeightInt) > gridSize)
                    sumLeft = sumLeft + grid{1}(-gridSize+(i+k*(gridHeightInt)),3);    

                else
                    sumRight = sumRight + grid{1}(i + k*gridHeightInt, 3);
                end
            end
            
            if round(sumUp) <= 5 || round(sumDown) <=5 || round(sumLeft) <=5 || round(sumRight) <=5
                columnPorosity = columnPorosity + 1;
            else
                innerColumnPorosity = innerColumnPorosity + 1;
            end

        end
    end
end
sites = j;

%Find the total number of atoms in the region.
%atomTotal = sum(gridMeasured(:,3));
porosity(1) = 1 - atomTotal/sites

%Need to determine whether this is inter/intra columnar porosity.
%An easy way to do this is to look in the 4 cardinal directions and
%evaluate porosity. Let's look at 10 locations each way and say its
%inter columnar pores if 75% are porous in any one direction.
% columnPorosity = 0;
% innerColumnPorosity = 0;
% for i =1:grid
%     if gridMeasured(i,3) == 0
%         sumUp = 0;
%         sumDown = 0;
%         sumLeft = 0;
%         sumRight = 0;
%         
%         for j = 1:10
%             sumUp = sumUp + grid{1}(i+substrateWidth*j,3);
%             sumDown = sumDown + grid{1}(firstIndex+i - substrateWidth*j, 3);
%             sumLeft = sumLeft + grid{1}(firstIndex+i-j,3);
%             sumRight = sumRight + grid{1}(firstIndex+i + j, 3);
%         end
%         
%         if sumUp >= 7 || sumDown >=7 || sumLeft >=7 || sumRight >=7
%             columnPorosity = columnPorosity + 1;
%         else
%             innerColumnPorosity = innerColumnPorosity + 1;
%         end
%     end
% end
%column pores (the big ones)
porosity(2) = columnPorosity/sites;
%inner column pore (little ones in the gaps)
porosity(3) = innerColumnPorosity/sites;
totalPorosity = (columnPorosity + innerColumnPorosity)/sites;

end