#!python3.2
#This program loops through numbered folders and generates plots for each folder.
#For use with a single line, comment out lines 19 and 45 and change line 8 to 2.
import numpy as np
import matplotlib.pyplot as plt
import os

n = 41

font = {'family' : 'Bitstream Vera Sans',
	'weight' : 'regular',
	'size'   : 20}

plt.rc('font', **font)

for j  in range(1, n):
	
	stringJ = str(j)
	os.chdir(stringJ)
	
	if  os.path.exists('grid315.csv') == True:
		heightLine = os.popen("tail -1" + " output.txt").readline()
		heightSplit = str.split(heightLine)
		height = int(heightSplit[4])
		gridData = np.loadtxt('grid315.csv', delimiter = ',', dtype = float)
		if j==1:
			xMax = np.max(gridData[:,0])
			yMax = np.max(gridData[:,1])
		
	
		i = 0

		gridFilled = gridData[:,2] == 1

		plt.figure(1)


		plt.hist2d(gridData[gridFilled,0]*1e6, gridData[gridFilled,1]*1e6, bins=[4001,height],cmap ='Greys_r', hold=False)
		ax = plt.gca()
		ax.axes.set_ylim(0, 0.7669130025)
		ax.axes.get_xaxis().set_visible(False)
		ax.axes.get_yaxis().set_visible(True) 	

		plt.savefig('gridMod2.png',dpi = 1200)
	os.chdir('../')