function[] = IADDistributionFinderEquals(x,y, filename, outputfile,reverse)

close all;
hold off;
waferFile = fopen(filename);

%Read in header lines
for i = 1:13
    fgetl(waferFile);
end
%Read in data from wafer file
wafertotal1 = fscanf(waferFile,'%f %f %f %f %f %f %f %f %f %f %f %f');
fclose(waferFile);


%Convert from vector to 2D array
[m,n] = size(wafertotal1);
j = 1;
for i = 1:12:m
    wafertotal(j,1:12) = wafertotal1(i:i+11);
    j = j+1;
end
[m,n] = size(wafertotal);
wafertotal(:,6);
j = 1;

wafercell = zeros(90,12);
%See if the data is within acceptable range and write it out if it is!
for i = 1:m
    if wafertotal(i,1) == x
        if wafertotal(i,2) == y 
            wafercell(j,:) = wafertotal(i,:);  
            j = j + 1;
        end
    end
end
wafercell(:,1:2);

cellsmooth = smooth(wafercell(:,6),11);
[c,i]=max(cellsmooth);
smoothNorm = cellsmooth/c;
wafercell(1:10,1:2);
wafercell(1,2)-wafercell(2,2)
%figure(1);
% plot(-90:2:90,wafercell(1:91,6)/max(wafercell(1:91,6)));
% hold on;
% plot(-90:2:90,smoothNorm(1:91),'-black');
% xlim([-90 90])
% ylim([0 1])
% xlabel(['Incidence angle'])
% ylabel(['Normalized Probability'])
% title(['IAD'])

smoothNorm(1) = 0.0;
smoothNorm(91) = 0.0;

if reverse == 1
    
    temp = smoothNorm(91:-1:1);
    smoothNorm = temp;
end
max(smoothNorm)
save(outputfile,'smoothNorm', '-ASCII')
end